'From Squeak 3.2 of 11 July 2002 [latest update: #4917] on 19 September 2002 at 4:52:30 pm'!
ProtoObject subclass: #Object
	instanceVariableNames: ''
	classVariableNames: 'DependentsFields EventsFields '
	poolDictionaries: ''
	category: 'Kernel-Objects'!

!Object commentStamp: '<historical>' prior: 0!
Object is the root class for almost all of the other classes in the class hierarchy. The exceptions are ProtoObject (the superclass of Object) and its subclasses.

Class Object provides default behavior common to all normal objects, such as access, copying, comparison, error handling, message sending, and reflection. Also utility messages that all objects should respond to are defined here.

Object has no instance variables, nor should any be added. This is due to several classes of objects that inherit from Object that have special implementations (SmallInteger and UndefinedObject for example) or the VM knows about and depends on the structure and layout of certain standard classes.

Class Variables:
	DependentsFields		an IdentityDictionary
		Provides a virtual 'dependents' field so that any object may have one
		or more dependent views, synchronized by the changed:/update: protocol.
		Note that class Model has a real slot for its dependents, and overrides
		the associated protocol with more efficient implementations.
	EventsFields			an IdentityDictionary that maps each object to its dependents.
		Registers a message send (consisting of a selector and a receiver object)
		which should be performed when anEventSymbol is triggered by the receiver.
		Part of a new event notification framework which could eventually replace
		the existing changed/update mechanism.  It is intended to be compatible
		with Dolphin Smalltalk and VSE as much as possible.

Because Object is the root of the inheritance tree, methods are often defined in Object to give all objects special behaviors needed by certain subsystems or applications, or to respond to certain general test messages such as isMorph.!

Object subclass: #Area
	instanceVariableNames: 'height width beastList obstacleList process processStarted processSuspended '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakLife-Engine'!
PasteUpMorph subclass: #AreaMorph
	instanceVariableNames: 'area '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakLife-Morph'!
Object subclass: #Beast
	instanceVariableNames: 'brain color front position maxSpeed currentSpeed direction viewDistance courseNb running coordX coordY '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakLife-Engine'!
EllipseMorph subclass: #BeastMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakLife-Morph'!
Object subclass: #Behaviour
	instanceVariableNames: 'area brain weight beast coursePossibilities '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakLife-Engine'!
Behaviour subclass: #BehaviourAvoid
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakLife-Engine'!
Behaviour subclass: #BehaviourFlock
	instanceVariableNames: 'leader '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakLife-Engine'!
Behaviour subclass: #BehaviourPredator
	instanceVariableNames: 'prey time '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakLife-Engine'!
Behaviour subclass: #BehaviourPsycho
	instanceVariableNames: 'victim time '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakLife-Engine'!
Behaviour subclass: #BehaviourRandom
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakLife-Engine'!
Behaviour subclass: #BehaviourRound
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakLife-Engine'!
Behaviour subclass: #BehaviourStraight
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakLife-Engine'!
Behaviour subclass: #BehaviourTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakLife-Engine'!
Object subclass: #Brain
	instanceVariableNames: 'beast behaviors area target '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakLife-Engine'!
Object subclass: #Calculation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakLife-Engine'!
Object class
	instanceVariableNames: ''!
Area class
	instanceVariableNames: ''!
AreaMorph class
	instanceVariableNames: ''!
Beast class
	instanceVariableNames: ''!
BeastMorph class
	instanceVariableNames: ''!
BehaviourAvoid class
	instanceVariableNames: ''!
BehaviourFlock class
	instanceVariableNames: ''!
BehaviourPredator class
	instanceVariableNames: ''!
BehaviourPsycho class
	instanceVariableNames: ''!
BehaviourRandom class
	instanceVariableNames: ''!
BehaviourRound class
	instanceVariableNames: ''!
BehaviourStraight class
	instanceVariableNames: ''!
BehaviourTarget class
	instanceVariableNames: ''!
Brain class
	instanceVariableNames: ''!
Calculation class
	instanceVariableNames: ''!
Object subclass: #Obstacle
	instanceVariableNames: 'position width height '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakLife-Engine'!
Obstacle class
	instanceVariableNames: ''!
Morph subclass: #ObstacleMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakLife-Morph'!
ObstacleMorph class
	instanceVariableNames: ''!
Object subclass: #SqueakLife
	instanceVariableNames: 'frame area areaMorph world '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakLife-Morph'!
SqueakLife class
	instanceVariableNames: ''!

!Object methodsFor: 'accessing' stamp: 'sw 4/30/1998 12:18'!
addInstanceVarNamed: aName withValue: aValue
	"Add an instance variable named aName and give it value aValue"
	self class addInstVarName: aName asString.
	self instVarAt: self class instSize put: aValue! !

!Object methodsFor: 'accessing' stamp: 'di 3/29/1999 11:39'!
at: index 
	"Primitive. Assumes receiver is indexable. Answer the value of an 
	indexable element in the receiver. Fail if the argument index is not an 
	Integer or is out of bounds. Essential. See Object documentation 
	whatIsAPrimitive."

	<primitive: 60>
	index isInteger ifTrue:
		[self class isVariable
			ifTrue: [self errorSubscriptBounds: index]
			ifFalse: [self error: (self class name) , 's are not indexable']].
	index isNumber
		ifTrue: [^self at: index asInteger]
		ifFalse: [self errorNonIntegerIndex]! !

!Object methodsFor: 'accessing'!
at: index modify: aBlock
	"Replace the element of the collection with itself transformed by the block"
	^ self at: index put: (aBlock value: (self at: index))! !

!Object methodsFor: 'accessing' stamp: 'di 3/29/1999 11:41'!
at: index put: value 
	"Primitive. Assumes receiver is indexable. Store the argument value in 
	the indexable element of the receiver indicated by index. Fail if the 
	index is not an Integer or is out of bounds. Or fail if the value is not of 
	the right type for this kind of collection. Answer the value that was 
	stored. Essential. See Object documentation whatIsAPrimitive."

	<primitive: 61>
	index isInteger ifTrue:
		[self class isVariable
			ifTrue: [(index >= 1 and: [index <= self size])
					ifTrue: [self errorImproperStore]
					ifFalse: [self errorSubscriptBounds: index]]
			ifFalse: [self error: (self class name) , 's are not indexable']].
	index isNumber
		ifTrue: [^self at: index asInteger put: value]
		ifFalse: [self errorNonIntegerIndex]! !

!Object methodsFor: 'accessing'!
basicAt: index 
	"Primitive. Assumes receiver is indexable. Answer the value of an 
	indexable element in the receiver. Fail if the argument index is not an 
	Integer or is out of bounds. Essential. Do not override in a subclass. See 
	Object documentation whatIsAPrimitive."

	<primitive: 60>
	index isInteger ifTrue: [self errorSubscriptBounds: index].
	index isNumber
		ifTrue: [^self basicAt: index asInteger]
		ifFalse: [self errorNonIntegerIndex]! !

!Object methodsFor: 'accessing'!
basicAt: index put: value 
	"Primitive. Assumes receiver is indexable. Store the second argument 
	value in the indexable element of the receiver indicated by index. Fail 
	if the index is not an Integer or is out of bounds. Or fail if the value is 
	not of the right type for this kind of collection. Answer the value that 
	was stored. Essential. Do not override in a subclass. See Object 
	documentation whatIsAPrimitive."

	<primitive: 61>
	index isInteger
		ifTrue: [(index >= 1 and: [index <= self size])
					ifTrue: [self errorImproperStore]
					ifFalse: [self errorSubscriptBounds: index]].
	index isNumber
		ifTrue: [^self basicAt: index asInteger put: value]
		ifFalse: [self errorNonIntegerIndex]! !

!Object methodsFor: 'accessing'!
basicSize
	"Primitive. Answer the number of indexable variables in the receiver. 
	This value is the same as the largest legal subscript. Essential. Do not 
	override in any subclass. See Object documentation whatIsAPrimitive."

	<primitive: 62>
	"The number of indexable fields of fixed-length objects is 0"
	^0	! !

!Object methodsFor: 'accessing'!
bindWithTemp: aBlock
	^ aBlock value: self value: nil! !

!Object methodsFor: 'accessing' stamp: 'di 11/8/2000 21:05'!
doIfNotNil: aBlock
	"Deprecated -- use ifNotNilDo:"

	^ self ifNotNilDo: aBlock
! !

!Object methodsFor: 'accessing' stamp: 'di 11/8/2000 21:04'!
ifNotNilDo: aBlock
	"Evaluate the given block with the receiver as its argument."

	^ aBlock value: self
! !

!Object methodsFor: 'accessing' stamp: 'tk 4/17/1999 10:09'!
in: aBlock
	"Evaluate the given block with the receiver as its argument."

	(aBlock isKindOf: BlockContext) ifFalse: [self error: 'expecting a block'].
	^ aBlock value: self
! !

!Object methodsFor: 'accessing' stamp: 'sw 10/17/2000 11:15'!
presenter
	"Answer the presenter object associated with the receiver.  For morphs, there is in effect a clear containment hierarchy of presenters (accessed via their association with PasteUpMorphs); for arbitrary objects the hook is simply via the current world, at least at present."

	^ self currentWorld presenter! !

!Object methodsFor: 'accessing'!
readFromString: aString
	"Create an object based on the contents of aString."

	^self readFrom: (ReadStream on: aString)! !

!Object methodsFor: 'accessing' stamp: 'di 3/29/1999 13:10'!
size
	"Primitive. Answer the number of indexable variables in the receiver. 
	This value is the same as the largest legal subscript. Essential. See Object 
	documentation whatIsAPrimitive."

	<primitive: 62>
	self class isVariable ifFalse: [self errorNotIndexable].
	^ 0! !

!Object methodsFor: 'accessing'!
yourself
	"Answer self."! !

!Object methodsFor: 'associating'!
-> anObject
	"Answer an Association between self and anObject"

	^Association new key: self value: anObject! !

!Object methodsFor: 'binding'!
bindingOf: aString
	^nil! !

!Object methodsFor: 'casing'!
caseOf: aBlockAssociationCollection
	"The elements of aBlockAssociationCollection are associations between blocks.
	 Answer the evaluated value of the first association in aBlockAssociationCollection
	 whose evaluated key equals the receiver.  If no match is found, report an error."

	^ self caseOf: aBlockAssociationCollection otherwise: [self caseError]

"| z | z _ {[#a]->[1+1]. ['b' asSymbol]->[2+2]. [#c]->[3+3]}. #b caseOf: z"
"| z | z _ {[#a]->[1+1]. ['d' asSymbol]->[2+2]. [#c]->[3+3]}. #b caseOf: z"
"The following are compiled in-line:"
"#b caseOf: {[#a]->[1+1]. ['b' asSymbol]->[2+2]. [#c]->[3+3]}"
"#b caseOf: {[#a]->[1+1]. ['d' asSymbol]->[2+2]. [#c]->[3+3]}"! !

!Object methodsFor: 'casing'!
caseOf: aBlockAssociationCollection otherwise: aBlock
	"The elements of aBlockAssociationCollection are associations between blocks.
	 Answer the evaluated value of the first association in aBlockAssociationCollection
	 whose evaluated key equals the receiver.  If no match is found, answer the result
	 of evaluating aBlock."

	aBlockAssociationCollection associationsDo:
		[:assoc | (assoc key value = self) ifTrue: [^assoc value value]].
	^ aBlock value

"| z | z _ {[#a]->[1+1]. ['b' asSymbol]->[2+2]. [#c]->[3+3]}. #b caseOf: z otherwise: [0]"
"| z | z _ {[#a]->[1+1]. ['d' asSymbol]->[2+2]. [#c]->[3+3]}. #b caseOf: z otherwise: [0]"
"The following are compiled in-line:"
"#b caseOf: {[#a]->[1+1]. ['b' asSymbol]->[2+2]. [#c]->[3+3]} otherwise: [0]"
"#b caseOf: {[#a]->[1+1]. ['d' asSymbol]->[2+2]. [#c]->[3+3]} otherwise: [0]"! !

!Object methodsFor: 'class membership'!
class
	"Primitive. Answer the object which is the receiver's class. Essential. See 
	Object documentation whatIsAPrimitive."

	<primitive: 111>
	self primitiveFailed! !

!Object methodsFor: 'class membership' stamp: 'sw 9/27/2001 15:51'!
inheritsFromAnyIn: aList
	"Answer whether the receiver inherits from any class represented by any element in the list.  The elements of the list can be classes, class name symbols, or strings representing possible class names.  This allows speculative membership tests to be made even when some of the classes may not be known to the current image, and even when their names are not interned symbols."

	| aClass |
	aList do:
		[:elem | Symbol hasInterned: elem asString ifTrue: 
			[:elemSymbol | (((aClass _ Smalltalk at: elemSymbol ifAbsent: [nil]) isKindOf: Class)
						and: [self isKindOf: aClass])
				ifTrue:
					[^ true]]].
	^ false


"
{3.  true. 'olive'} do:
	[:token |
		 {{#Number. #Boolean}. {Number.  Boolean }.  {'Number'. 'Boolean'}} do:
			[:list |
				Transcript cr; show: token asString, ' list element provided as a ', list first class name, ' - ', (token inheritsFromAnyIn: list) asString]]
"! !

!Object methodsFor: 'class membership'!
isKindOf: aClass 
	"Answer whether the class, aClass, is a superclass or class of the receiver."

	self class == aClass
		ifTrue: [^true]
		ifFalse: [^self class inheritsFrom: aClass]! !

!Object methodsFor: 'class membership' stamp: 'sw 2/16/98 02:08'!
isKindOf: aClass orOf: anotherClass
	"Answer whether either of the classes, aClass or anotherClass,, is a superclass or class of the receiver.  A convenience; could be somewhat optimized"
	^ (self isKindOf: aClass) or: [self isKindOf: anotherClass]! !

!Object methodsFor: 'class membership'!
isMemberOf: aClass 
	"Answer whether the receiver is an instance of the class, aClass."

	^self class == aClass! !

!Object methodsFor: 'class membership'!
respondsTo: aSymbol 
	"Answer whether the method dictionary of the receiver's class contains 
	aSymbol as a message selector."

	^self class canUnderstand: aSymbol! !

!Object methodsFor: 'class membership' stamp: 'tk 10/21/1998 12:38'!
xxxClass
	"For subclasses of nil, such as ObjectOut"
	^ self class! !

!Object methodsFor: 'comparing'!
= anObject 
	"Answer whether the receiver and the argument represent the same 
	object. If = is redefined in any subclass, consider also redefining the 
	message hash."

	^self == anObject! !

!Object methodsFor: 'comparing' stamp: 'tk 4/16/1999 18:26'!
closeTo: anObject
	"Answer whether the receiver and the argument represent the same
	object. If = is redefined in any subclass, consider also redefining the
	message hash."

	| ans |
	[ans _ self = anObject] ifError: [:aString :aReceiver | ^ false].
	^ ans! !

!Object methodsFor: 'comparing'!
hash
	"Answer a SmallInteger whose value is related to the receiver's identity.
	May be overridden, and should be overridden in any classes that define = "

	^ self identityHash! !

!Object methodsFor: 'comparing' stamp: 'pm 9/23/97 09:36'!
hashMappedBy: map
	"Answer what my hash would be if oops changed according to map."

	^map newHashFor: self! !

!Object methodsFor: 'comparing' stamp: 'di 9/27/97 20:23'!
identityHashMappedBy: map
	"Answer what my hash would be if oops changed according to map."

	^map newHashFor: self! !

!Object methodsFor: 'comparing' stamp: 'sw 8/20/1998 12:34'!
identityHashPrintString
	"'fred' identityHashPrintString"

	^ '(', self identityHash printString, ')'! !

!Object methodsFor: 'comparing'!
~= anObject 
	"Answer whether the receiver and the argument do not represent the 
	same object."

	^self = anObject == false! !

!Object methodsFor: 'converting' stamp: 'di 11/9/1998 12:15'!
adaptToFloat: rcvr andSend: selector
	"If no method has been provided for adapting an object to a Float,
	then it may be adequate to simply adapt it to a number."
	^ self adaptToNumber: rcvr andSend: selector! !

!Object methodsFor: 'converting' stamp: 'di 11/9/1998 12:14'!
adaptToFraction: rcvr andSend: selector
	"If no method has been provided for adapting an object to a Fraction,
	then it may be adequate to simply adapt it to a number."
	^ self adaptToNumber: rcvr andSend: selector! !

!Object methodsFor: 'converting' stamp: 'di 11/9/1998 12:15'!
adaptToInteger: rcvr andSend: selector
	"If no method has been provided for adapting an object to a Integer,
	then it may be adequate to simply adapt it to a number."
	^ self adaptToNumber: rcvr andSend: selector! !

!Object methodsFor: 'converting'!
as: aSimilarClass
	"Create an object of class aSimilarClass that has similar contents to the receiver."

	^ aSimilarClass newFrom: self! !

!Object methodsFor: 'converting' stamp: 'svp 5/16/2000 18:14'!
asDraggableMorph
	^(StringMorph contents: self printString)
		color: Color white;
		yourself! !

!Object methodsFor: 'converting' stamp: 'sma 5/12/2000 17:39'!
asOrderedCollection
	"Answer an OrderedCollection with the receiver as its only element."

	^ OrderedCollection with: self! !

!Object methodsFor: 'converting'!
asString
	"Answer a string that represents the receiver."

	^ self printString ! !

!Object methodsFor: 'converting' stamp: 'RAA 8/2/1999 12:41'!
complexContents

	^self! !

!Object methodsFor: 'converting' stamp: 'hmm 7/29/2001 21:35'!
mustBeBoolean
	"Catches attempts to test truth of non-Booleans.  This message is sent from the
	interpreter.
	The sending context is rewound to just before the jump causing this exception."

	| proceedValue |
	thisContext sender skipBackBeforeJump.
	proceedValue _ NonBooleanReceiver new
		object: self;
		signal: 'proceed for truth.'.
	^proceedValue ~~ false! !

!Object methodsFor: 'converting' stamp: 'sw 3/26/2001 12:12'!
printDirectlyToDisplay
	"For debugging: write the receiver's printString directly to the display at (0, 100); senders of this are detected by the check-for-slips mechanism."

	self asString displayAt: 0@100

"StringMorph someInstance printDirectlyToDisplay"! !

!Object methodsFor: 'converting' stamp: 'RAA 3/31/1999 12:13'!
withoutListWrapper

	^self! !

!Object methodsFor: 'copying'!
clone

	<primitive: 148>
	self primitiveFailed! !

!Object methodsFor: 'copying'!
copy
	"Answer another instance just like the receiver. Subclasses typically 
	override this method; they typically do not override shallowCopy."

	^self shallowCopy! !

!Object methodsFor: 'copying' stamp: 'tk 8/20/1998 16:01'!
copyAddedStateFrom: anotherObject
	"Copy over the values of instance variables added by the receiver's class from anotherObject to the receiver.  These will be remapped in mapUniClasses, if needed."

	self class superclass instSize + 1 to: self class instSize do:
		[:index | self instVarAt: index put: (anotherObject instVarAt: index)]! !

!Object methodsFor: 'copying' stamp: 'tk 11/27/1998 09:00'!
copyFrom: anotherObject
	"Copy to myself all instance variables I have in common with anotherObject.  This is dangerous because it ignores an object's control over its own inst vars.  "

	| mine his |
	mine _ self class allInstVarNames.
	his _ anotherObject class allInstVarNames.
	1 to: (mine size min: his size) do: [:ind |
		(mine at: ind) = (his at: ind) ifTrue: [
			self instVarAt: ind put: (anotherObject instVarAt: ind)]].
	self class isVariable & anotherObject class isVariable ifTrue: [
		1 to: (self basicSize min: anotherObject basicSize) do: [:ind |
			self basicAt: ind put: (anotherObject basicAt: ind)]].! !

!Object methodsFor: 'copying' stamp: 'di 6/9/1999 14:44'!
copySameFrom: otherObject
	"Copy to myself all instance variables named the same in otherObject.
	This ignores otherObject's control over its own inst vars."

	| myInstVars otherInstVars match |
	myInstVars _ self class allInstVarNames.
	otherInstVars _ otherObject class allInstVarNames.
	myInstVars doWithIndex: [:each :index |
		(match _ otherInstVars indexOf: each) > 0 ifTrue:
			[self instVarAt: index put: (otherObject instVarAt: match)]]
! !

!Object methodsFor: 'copying' stamp: 'tk 4/20/1999 14:44'!
copyTwoLevel
	"one more level than a shallowCopy"

	| newObject class index |
	class _ self class.
	newObject _ self clone.
	newObject == self ifTrue: [^ self].
	class isVariable
		ifTrue: 
			[index _ self basicSize.
			[index > 0]
				whileTrue: 
					[newObject basicAt: index put: (self basicAt: index) shallowCopy.
					index _ index - 1]].
	index _ class instSize.
	[index > 0]
		whileTrue: 
			[newObject instVarAt: index put: (self instVarAt: index) shallowCopy.
			index _ index - 1].
	^newObject! !

!Object methodsFor: 'copying'!
deepCopy
	"Answer a copy of the receiver with its own copy of each instance 
	variable."

	| newObject class index |
	class _ self class.
	(class == Object) ifTrue: [^self].
	class isVariable
		ifTrue: 
			[index _ self basicSize.
			newObject _ class basicNew: index.
			[index > 0]
				whileTrue: 
					[newObject basicAt: index put: (self basicAt: index) deepCopy.
					index _ index - 1]]
		ifFalse: [newObject _ class basicNew].
	index _ class instSize.
	[index > 0]
		whileTrue: 
			[newObject instVarAt: index put: (self instVarAt: index) deepCopy.
			index _ index - 1].
	^newObject! !

!Object methodsFor: 'copying' stamp: 'hg 11/23/1999 13:43'!
initialDeepCopierSize
	"default value is 4096; other classes may override this, esp. for smaller (=faster) sizes"

	^4096! !

!Object methodsFor: 'copying' stamp: 'jm 11/14/97 11:08'!
shallowCopy
	"Answer a copy of the receiver which shares the receiver's instance variables."
	| class newObject index |
	<primitive: 148>
	class _ self class.
	class isVariable
		ifTrue: 
			[index _ self basicSize.
			newObject _ class basicNew: index.
			[index > 0]
				whileTrue: 
					[newObject basicAt: index put: (self basicAt: index).
					index _ index - 1]]
		ifFalse: [newObject _ class basicNew].
	index _ class instSize.
	[index > 0]
		whileTrue: 
			[newObject instVarAt: index put: (self instVarAt: index).
			index _ index - 1].
	^ newObject! !

!Object methodsFor: 'copying' stamp: 'tk 1/2/2001 10:53'!
veryDeepCopy
	"Do a complete tree copy using a dictionary.  An object in the tree twice is only copied once.  All references to the object in the copy of the tree will point to the new copy."

	| copier new refs newDep newModel |
	copier _ DeepCopier new initialize: self initialDeepCopierSize.
	new _ self veryDeepCopyWith: copier.
	copier mapUniClasses.
	copier references associationsDo: [:assoc | 
		assoc value veryDeepFixupWith: copier].
	"Fix dependents"
	refs _ copier references.
	DependentsFields associationsDo: [:pair |
		pair value do: [:dep | 
			(newDep _ refs at: dep ifAbsent: [nil]) ifNotNil: [
				newModel _ refs at: pair key ifAbsent: [pair key].
				newModel addDependent: newDep]]].
	^ new! !

!Object methodsFor: 'copying' stamp: 'tk 9/4/2001 10:51'!
veryDeepCopyWith: deepCopier
	"Copy me and the entire tree of objects I point to.  An object in the tree twice is copied once, and both references point to him.  deepCopier holds a dictionary of objects we have seen.  Some classes refuse to be copied.  Some classes are picky about which fields get deep copied."
	| class index sub subAss new uc sup has mine |
	deepCopier references at: self ifPresent: [:newer | ^ newer]. 	"already did him"
	class _ self class.
	class isMeta ifTrue: [^ self].		"a class"
	new _ self clone.
	class isSystemDefined ifFalse: [
		uc _ deepCopier uniClasses at: class ifAbsent: [nil].
		uc ifNil: [
			deepCopier uniClasses at: class put: (uc _ self copyUniClassWith: deepCopier).
			deepCopier references at: class put: uc].	"remember"
		new _ uc new.
		new copyFrom: self].	"copy inst vars in case any are weak"
	deepCopier references at: self put: new.	"remember"
	(class isVariable and: [class isPointers]) ifTrue: 
		[index _ self basicSize.
		[index > 0] whileTrue: 
			[sub _ self basicAt: index.
			(subAss _ deepCopier references associationAt: sub ifAbsent: [nil])
				ifNil: [new basicAt: index put: (sub veryDeepCopyWith: deepCopier)]
				ifNotNil: [new basicAt: index put: subAss value].
			index _ index - 1]].
	"Ask each superclass if it wants to share (weak copy) any inst vars"
	new veryDeepInner: deepCopier.		"does super a lot"

	"other superclasses want all inst vars deep copied"
	sup _ class.  index _ class instSize.
	[has _ sup compiledMethodAt: #veryDeepInner: ifAbsent: [nil].
	has _ has ifNil: [class isSystemDefined not "is a uniClass"] ifNotNil: [true].
	mine _ sup instVarNames.
	has ifTrue: [index _ index - mine size]	"skip inst vars"
		ifFalse: [1 to: mine size do: [:xx |
				sub _ self instVarAt: index.
				(subAss _ deepCopier references associationAt: sub ifAbsent: [nil])
						"use association, not value, so nil is an exceptional value"
					ifNil: [new instVarAt: index put: 
								(sub veryDeepCopyWith: deepCopier)]
					ifNotNil: [new instVarAt: index put: subAss value].
				index _ index - 1]].
	(sup _ sup superclass) == nil] whileFalse.
	new rehash.	"force Sets and Dictionaries to rehash"
	^ new
! !

!Object methodsFor: 'copying' stamp: 'tk 2/16/2001 10:07'!
veryDeepCopyWithSiblingOf: oldObject
	"Do a complete tree copy using a dictionary.  Substitute a clone of oldObject (a Player) for it.  Normally, a Player or non systemDefined object would have a new class.  We do not want one this time.  An object in the tree twice is only copied once.  All references to the object in the copy of the tree will point to the new copy."

	| copier new refs newDep newModel newObject |
	copier _ DeepCopier new initialize: self initialDeepCopierSize.
	newObject _ oldObject clone.		"Don't redefine clone for Players"
	copier references at: oldObject put: newObject.
	new _ self veryDeepCopyWith: copier.
	newObject veryDeepPvtSibling: copier.
	copier mapUniClasses.
	copier references associationsDo: [:assoc | 
		assoc value veryDeepFixupWith: copier].
	"Fix dependents"
	refs _ copier references.
	DependentsFields associationsDo: [:pair |
		pair value do: [:dep | 
			(newDep _ refs at: dep ifAbsent: [nil]) ifNotNil: [
				newModel _ refs at: pair key ifAbsent: [pair key].
				newModel addDependent: newDep]]].
	^ new! !

!Object methodsFor: 'copying' stamp: 'tk 1/6/1999 17:39'!
veryDeepFixupWith: deepCopier
	"I have no fields and no superclass.  Catch the super call."
! !

!Object methodsFor: 'copying' stamp: 'tk 9/4/2001 10:30'!
veryDeepInner: deepCopier
	"No special treatment for inst vars of my superclasses.  Override when some need to be weakly copied.  Object>>veryDeepCopyWith: will veryDeepCopy any inst var whose class does not actually define veryDeepInner:"
! !

!Object methodsFor: 'copying' stamp: 'tk 9/4/2001 17:57'!
veryDeepPvtSibling: deepCopier
	"Copy the instance variables of a new sibling of a Player.  Private method."
	| index sub subAss sup has mine |

	"Ask each superclass if it wants to share (weak copy) any inst vars"
	self veryDeepInner: deepCopier.		"does super a lot"

	"other superclasses want all inst vars deep copied"
	sup _ self class.  index _ self class instSize.
	[has _ sup compiledMethodAt: #veryDeepInner: ifAbsent: [nil].
	has _ has ifNil: [self class isSystemDefined not "is a uniClass"] ifNotNil: [true].
	mine _ sup instVarNames.
	has ifTrue: [index _ index - mine size]	"skip inst vars"
		ifFalse: [1 to: mine size do: [:xx |
				sub _ self instVarAt: index.
				(subAss _ deepCopier references associationAt: sub ifAbsent: [nil])
						"use association, not value, so nil is an exceptional value"
					ifNil: [self instVarAt: index put: 
								(sub veryDeepCopyWith: deepCopier)]
					ifNotNil: [self instVarAt: index put: subAss value].
				index _ index - 1]].
	(sup _ sup superclass) == nil] whileFalse.

	self rehash. 	"force Sets and Dictionaries to rehash"
! !

!Object methodsFor: 'dependents access' stamp: 'ar 2/11/2001 01:55'!
addDependent: anObject
	"Make the given object one of the receiver's dependents."

	| dependents |
	dependents _ self dependents.
	(dependents includes: anObject) ifFalse:
		[self myDependents: (dependents copyWithDependent: anObject)].
	^ anObject! !

!Object methodsFor: 'dependents access' stamp: 'sma 2/29/2000 19:53'!
breakDependents
	"Remove all of the receiver's dependents."

	self myDependents: nil! !

!Object methodsFor: 'dependents access' stamp: 'sma 2/29/2000 19:26'!
canDiscardEdits
	"Answer true if none of the views on this model has unaccepted edits that matter."

	self dependents
		do: [:each | each canDiscardEdits ifFalse: [^ false]]
		without: self.
	^ true! !

!Object methodsFor: 'dependents access' stamp: 'sma 2/29/2000 19:58'!
dependents
	"Answer a collection of objects that are 'dependent' on the receiver;
	 that is, all objects that should be notified if the receiver changes."

	^ self myDependents ifNil: [#()]! !

!Object methodsFor: 'dependents access'!
evaluate: actionBlock wheneverChangeIn: aspectBlock
	| viewerThenObject objectThenViewer |
	objectThenViewer _ self.
	viewerThenObject _ ObjectViewer on: objectThenViewer.
	objectThenViewer become: viewerThenObject.
	"--- Then ---"
	objectThenViewer xxxViewedObject: viewerThenObject
			evaluate: actionBlock
			wheneverChangeIn: aspectBlock! !

!Object methodsFor: 'dependents access' stamp: 'sma 2/29/2000 19:59'!
hasUnacceptedEdits
	"Answer true if any of the views on this object has unaccepted edits."

	self dependents
		do: [:each | each hasUnacceptedEdits ifTrue: [^ true]]
		without: self.
	^ false! !

!Object methodsFor: 'dependents access' stamp: 'sma 2/29/2000 19:55'!
myDependents
	"Private. Answer a list of all the receiver's dependents."

	^ DependentsFields at: self ifAbsent: []! !

!Object methodsFor: 'dependents access' stamp: 'sma 2/29/2000 19:52'!
myDependents: aCollectionOrNil
	"Private. Set (or remove) the receiver's dependents list."

	aCollectionOrNil
		ifNil: [DependentsFields removeKey: self ifAbsent: []]
		ifNotNil: [DependentsFields at: self put: aCollectionOrNil]! !

!Object methodsFor: 'dependents access' stamp: 'sma 2/29/2000 20:26'!
release
	"Remove references to objects that may refer to the receiver. This message 
	should be overridden by subclasses with any cycles, in which case the 
	subclass should also include the expression super release."

	self breakDependents.
	self removeAllEventsTriggered! !

!Object methodsFor: 'dependents access' stamp: 'sma 2/29/2000 20:23'!
removeDependent: anObject
	"Remove the given object as one of the receiver's dependents."

	| dependents |
	dependents _ self dependents reject: [:each | each == anObject].
	self myDependents: (dependents isEmpty ifFalse: [dependents]).
	^ anObject! !

!Object methodsFor: 'drag and drop' stamp: 'bh 9/16/2001 18:10'!
acceptDroppingMorph: transferMorph event: evt inMorph: dstListMorph 
	
	^false.! !

!Object methodsFor: 'drag and drop' stamp: 'mir 5/16/2000 11:35'!
dragAnimationFor: item transferMorph: transferMorph 
	"Default do nothing"! !

!Object methodsFor: 'drag and drop' stamp: 'panda 4/28/2000 16:20'!
dragPassengerFor: item inMorph: dragSource 
	^item! !

!Object methodsFor: 'drag and drop' stamp: 'panda 4/28/2000 16:11'!
dragTransferType
	^nil! !

!Object methodsFor: 'drag and drop' stamp: 'panda 4/28/2000 16:05'!
dragTransferTypeForMorph: dragSource 
	^nil! !

!Object methodsFor: 'drag and drop' stamp: 'mir 5/8/2000 17:19'!
wantsDroppedMorph: aMorph event: anEvent inMorph: destinationLM 
	^false! !

!Object methodsFor: 'error handling' stamp: 'sma 5/6/2000 19:35'!
assert: aBlock
	"Throw an assertion error if aBlock does not evaluates to true."

	aBlock value ifFalse: [AssertionFailure signal: 'Assertion failed']! !

!Object methodsFor: 'error handling' stamp: 'hg 10/2/2001 20:43'!
cannotInterpret: aMessage 
	 "Handle the fact that there was an attempt to send the given message to the receiver but a null methodDictionary was encountered while looking up the message selector.  Hopefully this is the result of encountering a stub for a swapped out class which induces this exception on purpose."

"If this is the result of encountering a swap-out stub, then simulating the lookup in Smalltalk should suffice to install the class properly, and the message may be resent."

	| handler errorString |
	(self class lookupSelector: aMessage selector) == nil ifFalse:
		["Simulated lookup succeeded -- resend the message."
		^ aMessage sentTo: self].

	"Could not recover by simulated lookup -- it's an error"
	errorString _ 'MethodDictionary fault'.
	(handler _ Processor activeProcess errorHandler) notNil
		ifTrue: [handler value: errorString value: self]
		ifFalse: [Debugger openContext: thisContext
					label: errorString
					contents: nil].
	^ aMessage sentTo: self! !

!Object methodsFor: 'error handling'!
caseError
	"Report an error from an in-line or explicit case statement."

	self error: 'Case not found, and no otherwise clause'! !

!Object methodsFor: 'error handling' stamp: 'sma 5/28/2000 15:48'!
confirm: queryString
	"Put up a yes/no menu with caption queryString. Answer true if the 
	response is yes, false if no. This is a modal question--the user must 
	respond yes or no."

	"nil confirm: 'Are you hungry?'"

	^ PopUpMenu confirm: queryString! !

!Object methodsFor: 'error handling' stamp: 'sma 5/28/2000 15:55'!
confirm: aString orCancel: cancelBlock
	"Put up a yes/no/cancel menu with caption aString. Answer true if  
	the response is yes, false if no. If cancel is chosen, evaluate  
	cancelBlock. This is a modal question--the user must respond yes or no."

	^ PopUpMenu confirm: aString orCancel: cancelBlock! !

!Object methodsFor: 'error handling' stamp: 'tfei 4/12/1999 10:20'!
doesNotUnderstand: aMessage 
	 "Handle the fact that there was an attempt to send the given message to the receiver but the receiver does not understand this message (typically sent from the machine when a message is sent to the receiver and no method is defined for that selector)."
	"Testing: (3 activeProcess)"

	(Preferences autoAccessors and: [self tryToDefineVariableAccess: aMessage])
		ifTrue: [^ aMessage sentTo: self].
	MessageNotUnderstood new message: aMessage;
		signal.
	^aMessage sentTo: self! !

!Object methodsFor: 'error handling' stamp: 'tfei 4/12/1999 12:55'!
error: aString 
	"Throw a generic Error exception."

	^Error new signal: aString! !

!Object methodsFor: 'error handling' stamp: 'ar 2/13/2001 20:49'!
externalCallFailed
	"A call to an external function has failed."
	^(Smalltalk at: #ExternalFunction ifAbsent:[^self error: 'FFI not installed'])
		externalCallFailed! !

!Object methodsFor: 'error handling' stamp: 'tfei 4/12/1999 12:54'!
halt
	"This is the typical message to use for inserting breakpoints during 
	debugging. It behaves like halt:, but does not call on halt: in order to 
	avoid putting this message on the stack. Halt is especially useful when 
	the breakpoint message is an arbitrary one."

	Halt signal! !

!Object methodsFor: 'error handling' stamp: 'tfei 4/12/1999 12:59'!
halt: aString 
	"This is the typical message to use for inserting breakpoints during 
	debugging. It creates and schedules a Notifier with the argument, 
	aString, as the label."
	
	Halt new signal: aString! !

!Object methodsFor: 'error handling' stamp: 'bf 9/27/1999 17:14'!
handles: exception
	"This method exists to break an endless loop in Exception>>findHandlerFrom: if the exception
is invalid"
	^false! !

!Object methodsFor: 'error handling' stamp: 'hg 10/2/2001 20:49'!
notify: aString 
	"Create and schedule a Notifier with the argument as the message in 
	order to request confirmation before a process can proceed."

	Warning signal: aString

	"nil notify: 'confirmation message'"! !

!Object methodsFor: 'error handling'!
notify: aString at: location
	"Create and schedule a Notifier with the argument as the message in 
	order to request confirmation before a process can proceed. Subclasses can
	override this and insert an error message at location within aString."

	self notify: aString

	"nil notify: 'confirmation message' at: 12"! !

!Object methodsFor: 'error handling' stamp: 'sw 5/23/2001 13:43'!
notifyWithLabel: aString 
	"Create and schedule a Notifier with aString as the window label as well as the contents of the window, in  order to request confirmation before a process can proceed."

	Debugger
		openContext: thisContext
		label: aString
		contents: aString

	"nil notifyWithLabel: 'let us see if this works'"! !

!Object methodsFor: 'error handling'!
primitiveFailed
	"Announce that a primitive has failed and there is no appropriate 
	Smalltalk code to run."

	self error: 'a primitive has failed'! !

!Object methodsFor: 'error handling'!
shouldNotImplement
	"Announce that, although the receiver inherits this message, it should 
	not implement it."

	self error: 'This message is not appropriate for this object'! !

!Object methodsFor: 'error handling'!
subclassResponsibility
	"This message sets up a framework for the behavior of the class' 
	subclasses. Announce that the subclass should have implemented this 
	message."

	self error: 'My subclass should have overridden one of my messages.'! !

!Object methodsFor: 'error handling' stamp: 'tk 6/18/2001 15:04'!
tryToDefineVariableAccess: aMessage
	"See if the message just wants to get at an instance variable of this class.  Ask the user if its OK.  If so, define the message to read or write that instance or class variable and retry."
	| ask newMessage sel canDo classOrSuper |
	aMessage arguments size > 1 ifTrue: [^ false].
	sel _ aMessage selector asString.	"works for 0 args"
	aMessage arguments size = 1 ifTrue: [
		sel last = $: ifFalse: [^ false].
		sel _ sel copyWithout: $:].
	canDo _ false.  classOrSuper _ self class.
	[((classOrSuper instVarNames includes: sel) 	
		ifTrue: [canDo _ true. nil]
		ifFalse: [classOrSuper _ classOrSuper superclass]) == nil] whileFalse.
	canDo ifFalse: [classOrSuper _ self class.
		[((classOrSuper classVarNames includes: sel) 	
			ifTrue: [canDo _ true. nil]
			ifFalse: [classOrSuper _ classOrSuper superclass]) == nil] whileFalse].
	canDo ifFalse: [^ false].

	ask _ self confirm: 'A ', thisContext sender sender receiver 
		class printString, ' wants to ', 
		(aMessage arguments size = 1 ifTrue: ['write into'] ifFalse: ['read from']), '
', sel ,' in class ', classOrSuper printString, '.
Define a this access message?'.
	ask ifTrue: [
		aMessage arguments size = 1 
			ifTrue: [newMessage _ aMessage selector, ' anObject
	', sel, ' _ anObject']
			ifFalse: [newMessage _ aMessage selector, '
	^', aMessage selector].
		classOrSuper compile: newMessage classified: 'accessing' notifying: nil].
	^ ask! !

!Object methodsFor: 'events' stamp: 'sma 2/29/2000 21:12'!
myEvents
	"Private. Answer a Dictionary with the receiver's events or nil if no
	events have been registered. Subclasses may overwrite this method
	for performance reasons."

	^ EventsFields at: self ifAbsent: []! !

!Object methodsFor: 'events' stamp: 'sma 2/29/2000 21:13'!
myEvents: aDictionaryOrNil
	"Private. Set (or remove) the receiver's dictionary of events.
	Subclasses may overwrite this method for performance reasons."

	aDictionaryOrNil
		ifNil: [EventsFields removeKey: self ifAbsent: []]
		ifNotNil: [EventsFields at: self put: aDictionaryOrNil]! !

!Object methodsFor: 'events' stamp: 'sma 2/29/2000 20:22'!
noEventsDo: aBlock
	"Evaluate aBlock while ensuring that the receiver will not trigger
	any events. Answer the result of evaluating aBlock."

	| events |
	events _ self myEvents.
	^ [self myEvents: nil. aBlock value] ensure: [self myEvents: events]! !

!Object methodsFor: 'events' stamp: 'sma 2/29/2000 20:26'!
removeAllEventsTriggered
	"Remove all events triggered by the receiver."

	self myEvents: nil! !

!Object methodsFor: 'events' stamp: 'ar 2/11/2001 02:22'!
removeEvent: eventName
	| events |
	events _ self myEvents ifNil:[^self].
	events removeKey: eventName ifAbsent:[].
	events isEmpty ifTrue:[self myEvents: nil].! !

!Object methodsFor: 'events' stamp: 'sma 2/29/2000 21:14'!
removeEventsTriggeredFor: anObject
	"Remove all that events trigged by the receiver which would have
	been send to anObject."

	| events |
	events _ self myEvents ifNil: [^ self].
	events copy keysAndValuesDo:
		[:evtSym :msgSendSet |
		| newSet |
		newSet _ msgSendSet reject: [:each | each receiver == anObject].
		msgSendSet size = newSet size ifFalse:
			[newSet isEmpty
				ifTrue: [events removeKey: evtSym]
				ifFalse: [events at: evtSym put: newSet]]].
	self myEvents: (events isEmpty ifFalse: [events])! !

!Object methodsFor: 'events' stamp: 'ar 2/11/2001 02:34'!
trigger: anEventSymbol
	"Evaluate all message sends registered for anEventSymbol."
	| msgSet any |
	msgSet _ (self myEvents ifNil:[^self]) at: anEventSymbol ifAbsent:[^self].
	any _ false.
	msgSet do:[:msg|
		msg value.
		any _ true].
	any ifFalse:[self removeEvent: anEventSymbol].! !

!Object methodsFor: 'events' stamp: 'sma 2/29/2000 21:18'!
trigger: anEventSymbol with: aParameter
	"Evaluate all message sends registered for anEventSymbol
	and pass aParamter to the registered actions."

	self trigger: anEventSymbol withArguments: (Array with: aParameter)! !

!Object methodsFor: 'events' stamp: 'ar 2/11/2001 02:34'!
trigger: anEventSymbol withArguments: anArray
	"Evaluate all message sends registered for anEventSymbol
	and pass anArray to the registered actions."
	| msgSet any |
	msgSet _ (self myEvents ifNil:[^self]) at: anEventSymbol ifAbsent:[^self].
	any _ false.
	msgSet do:[:msg|
		msg valueWithArguments: anArray.
		any _ true].
	any ifFalse:[self removeEvent: anEventSymbol].! !

!Object methodsFor: 'events' stamp: 'ar 2/11/2001 02:13'!
when: anEventSymbol perform: aMessageSend
	"Register aMessageSend as action for anEventSymbol."

	| events |
	(events _ self myEvents) ifNil:
		[self myEvents: (events _ IdentityDictionary new)].
	(events
		at: anEventSymbol 
		ifAbsentPut: [EventMessageSet new]) add: aMessageSend! !

!Object methodsFor: 'events' stamp: 'sma 2/29/2000 20:47'!
when: anEventSymbol send: aSelector to: anObject
	self
		when: anEventSymbol
		perform: (MessageSend receiver: anObject selector: aSelector)! !

!Object methodsFor: 'events' stamp: 'sma 2/29/2000 20:49'!
when: anEventSymbol send: aSelector to: anObject with: anArgument
	self
		when: anEventSymbol
		perform: (MessageSend receiver: anObject selector: aSelector argument: anArgument)! !

!Object methodsFor: 'events' stamp: 'sma 2/29/2000 20:48'!
when: anEventSymbol send: aSelector to: anObject withArguments: anArray
	self
		when: anEventSymbol
		perform: (MessageSend receiver: anObject selector: aSelector arguments: anArray)! !

!Object methodsFor: 'events' stamp: 'sma 2/29/2000 20:32'!
when: anEventSymbol sendTo: anObject
	self when: anEventSymbol send: anEventSymbol to: anObject! !

!Object methodsFor: 'filter streaming' stamp: 'MPW 1/1/1901 00:42'!
byteEncode:aStream
	self flattenOnStream:aStream.
! !

!Object methodsFor: 'filter streaming'!
drawOnCanvas:aStream
	self flattenOnStream:aStream.
! !

!Object methodsFor: 'filter streaming' stamp: 'MPW 1/1/1901 01:31'!
elementSeparator
	^nil.! !

!Object methodsFor: 'filter streaming'!
encodePostscriptOn:aStream
	self byteEncode:aStream.
! !

!Object methodsFor: 'filter streaming' stamp: 'MPW 1/1/1901 00:07'!
flattenOnStream:aStream
	self writeOnFilterStream:aStream.
! !

!Object methodsFor: 'filter streaming' stamp: 'mpw 6/22/1930 22:56'!
fullDrawPostscriptOn:aStream
	^aStream fullDraw:self.
! !

!Object methodsFor: 'filter streaming' stamp: 'MPW 1/1/1901 01:51'!
printOnStream:aStream
	self byteEncode:aStream.
! !

!Object methodsFor: 'filter streaming' stamp: 'MPW 1/1/1901 00:49'!
putOn:aStream
	^aStream nextPut:self.
! !

!Object methodsFor: 'filter streaming' stamp: 'MPW 1/1/1901 01:53'!
storeOnStream:aStream
	self printOnStream:aStream.
! !

!Object methodsFor: 'filter streaming' stamp: 'MPW 1/1/1901 00:06'!
writeOnFilterStream:aStream
	aStream writeObject:self.
! !

!Object methodsFor: 'finalization' stamp: 'ar 3/21/98 16:26'!
actAsExecutor
	"Prepare the receiver to act as executor for any resources associated with it"
	self breakDependents! !

!Object methodsFor: 'finalization' stamp: 'ar 3/20/98 22:19'!
executor
	"Return an object which can act as executor for finalization of the receiver"
	^self shallowCopy actAsExecutor! !

!Object methodsFor: 'finalization' stamp: 'ar 3/21/98 16:27'!
finalize
	"Finalize the resource associated with the receiver. This message should only be sent during the finalization process. There is NO garantuee that the resource associated with the receiver hasn't been free'd before so take care that you don't run into trouble - this all may happen with interrupt priority."! !

!Object methodsFor: 'finalization' stamp: 'ar 3/21/98 18:38'!
retryWithGC: execBlock until: testBlock
	"Retry execBlock as long as testBlock returns false. Do an incremental GC after the first try, a full GC after the second try."
	| blockValue |
	blockValue := execBlock value.
	(testBlock value: blockValue) ifTrue:[^blockValue].
	Smalltalk garbageCollectMost.
	blockValue := execBlock value.
	(testBlock value: blockValue) ifTrue:[^blockValue].
	Smalltalk garbageCollect.
	^execBlock value.! !

!Object methodsFor: 'flagging' stamp: 'sw 8/4/97 16:49'!
isThisEverCalled
	^ self isThisEverCalled: thisContext sender printString! !

!Object methodsFor: 'flagging'!
isThisEverCalled: msg
	"Send this message, with some useful printable argument, from methods or branches of methods which you believe are never reached.  2/5/96 sw"

	self halt: 'This is indeed called: ', msg printString! !

!Object methodsFor: 'flagging' stamp: 'jm 3/18/98 17:23'!
logEntry

	Transcript show: 'Entered ', thisContext sender printString; cr.
! !

!Object methodsFor: 'flagging' stamp: 'jm 3/18/98 17:23'!
logExecution

	Transcript show: 'Executing ', thisContext sender printString; cr.
! !

!Object methodsFor: 'flagging' stamp: 'jm 3/18/98 17:22'!
logExit

	Transcript show:  'Exited ', thisContext sender printString; cr.
! !

!Object methodsFor: 'logging' stamp: 'RAA 3/9/2001 08:13'!
flag: aFlagString log: aString

	"since this is now being called from other processes by project resource loading, we need something a bit more thread-safe"

	"Transcript show: aString; cr"
	! !

!Object methodsFor: 'logging' stamp: 'mir 8/10/1999 16:05'!
flag: aFlagString streamLog: aBlockWithStreamArgument
	! !

!Object methodsFor: 'macpal' stamp: 'sw 12/14/2000 10:46'!
beep: soundName
	"Make the given sound, unless the making of sound is disabled in Preferences"

	Preferences soundsEnabled
		ifTrue: [self playSoundNamed: soundName]
! !

!Object methodsFor: 'macpal' stamp: 'sw 5/7/1998 23:00'!
codeStrippedOut: messageString
	"When a method is stripped out for external release, it is replaced by a method that calls this"

	self halt: 'Code stripped out -- ', messageString, '-- do not proceed.'! !

!Object methodsFor: 'macpal' stamp: 'sw 1/28/1999 17:31'!
contentsChanged
	self changed: #contents! !

!Object methodsFor: 'macpal' stamp: 'ar 3/18/2001 00:03'!
currentEvent
	"Answer the current Morphic event.  This method never returns nil."
	^ActiveEvent ifNil:[self currentHand lastEvent]! !

!Object methodsFor: 'macpal' stamp: 'ar 3/18/2001 00:03'!
currentHand
	"Return a usable HandMorph -- the one associated with the object's current environment.  This method will always return a hand, even if it has to conjure one up as a last resort.  If a particular hand is actually handling events at the moment (such as a remote hand or a ghost hand), it will be returned."

	^ActiveHand! !

!Object methodsFor: 'macpal' stamp: 'sw 5/17/2001 12:08'!
currentVocabulary
	"Answer the currently-prevailing default vocabulary."

	^ Smalltalk isMorphic ifTrue:
			[ActiveWorld currentVocabulary]
		ifFalse:
			[Vocabulary fullVocabulary]! !

!Object methodsFor: 'macpal' stamp: 'ar 3/18/2001 00:08'!
currentWorld
	"Answer a morphic world that is the current UI focus.
		If in an embedded world, it's that world.
		If in a morphic project, it's that project's world.  
		If in an mvc project, it is the topmost morphic-mvc-window's worldMorph. 
		If in an mvc project that has no morphic-mvc-windows, then it's just some existing worldmorph instance.
		If in an mvc project in a Squeak that has NO WorldMorph instances, one is created.

	This method will never return nil, it will always return its best effort at returning a relevant world morph, but if need be -- if there are no worlds anywhere, it will create a new one."

	| aView aSubview |
	ActiveWorld ifNotNil:[^ActiveWorld].
	World ifNotNil:[^World].
	aView _ ScheduledControllers controllerSatisfying:
		[:ctrl | (aSubview _ ctrl view firstSubView) notNil and:
			[aSubview model isMorph and: [aSubview model isWorldMorph]]].
	^aView
		ifNotNil:
			[aSubview model]
		ifNil:
			[MVCWiWPasteUpMorph newWorldForProject: nil].! !

!Object methodsFor: 'macpal' stamp: 'jm 5/6/1998 22:35'!
flash
	"Do nothing."
! !

!Object methodsFor: 'macpal' stamp: 'sw 10/13/97 16:38'!
ifKindOf: aClass thenDo: aBlock
	^ (self isKindOf: aClass) ifTrue: [aBlock value: self]! !

!Object methodsFor: 'macpal' stamp: 'sw 6/16/1998 15:07'!
instanceVariableValues
	"Answer a collection whose elements are the values of those instance variables of the receiver which were added by the receiver's class"
	| c |
	c _ OrderedCollection new.
	self class superclass instSize + 1 to: self class instSize do:
		[:i | c add: (self instVarAt: i)].
	^ c! !

!Object methodsFor: 'macpal' stamp: 'sw 3/20/2001 13:29'!
isUniversalTiles
	"Return true if I (my world) uses universal tiles.  This message can be called in places where the current World is not known, such as when writing out a project.  For more information about the project-writing subtlety addressed by this protocol, kindly contact Ted Kaehler."

	^ Preferences universalTiles! !

!Object methodsFor: 'macpal' stamp: 'sw 10/24/2000 07:04'!
objectRepresented
	"most objects represent themselves; this provides a hook for aliases to grab on to"

	^ self! !

!Object methodsFor: 'macpal' stamp: 'jm 5/16/1998 10:32'!
playSoundNamed: soundName
	"Play the sound with the given name. Do nothing if this image lacks sound playing facilities."

	Smalltalk at: #SampledSound ifPresent: [:sampledSound |
		sampledSound playSoundNamed: soundName asString].
! !

!Object methodsFor: 'macpal' stamp: 'sw 5/22/2001 18:31'!
refusesToAcceptCode
	"Answer whether the receiver is a code-bearing instrument which at the moment refuses to allow its contents to be submitted"

	^ false
	! !

!Object methodsFor: 'macpal' stamp: 'jm 2/24/1999 12:40'!
scriptPerformer

	^ self
! !

!Object methodsFor: 'macpal' stamp: 'sw 3/20/2001 13:40'!
slotInfo
	"Answer a list of slot-information objects.  Initally only provides useful info for players"

	^ Dictionary new! !

!Object methodsFor: 'message handling' stamp: 'di 3/26/1999 07:52'!
perform: aSymbol 
	"Send the unary selector, aSymbol, to the receiver.
	Fail if the number of arguments expected by the selector is not zero.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 83>
	^ self perform: aSymbol withArguments: (Array new: 0)! !

!Object methodsFor: 'message handling' stamp: 'sw 10/30/1998 18:27'!
perform: selector orSendTo: otherTarget
	"If I wish to intercept and handle selector myself, do it; else send it to otherTarget"
	^ otherTarget perform: selector! !

!Object methodsFor: 'message handling' stamp: 'di 3/26/1999 07:52'!
perform: aSymbol with: anObject 
	"Send the selector, aSymbol, to the receiver with anObject as its argument.
	Fail if the number of arguments expected by the selector is not one.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 83>
	^ self perform: aSymbol withArguments: (Array with: anObject)! !

!Object methodsFor: 'message handling' stamp: 'di 3/26/1999 07:52'!
perform: aSymbol with: firstObject with: secondObject 
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not two.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 83>
	^ self perform: aSymbol withArguments: (Array with: firstObject with: secondObject)! !

!Object methodsFor: 'message handling' stamp: 'di 3/26/1999 07:51'!
perform: aSymbol with: firstObject with: secondObject with: thirdObject 
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 83>
	^ self perform: aSymbol
		withArguments: (Array with: firstObject with: secondObject with: thirdObject)! !

!Object methodsFor: 'message handling' stamp: 'di 3/26/1999 07:55'!
perform: selector withArguments: argArray 
	"Send the selector, aSymbol, to the receiver with arguments in argArray.
	Fail if the number of arguments expected by the selector 
	does not match the size of argArray.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 84>
	^ self perform: selector withArguments: argArray inSuperclass: self class! !

!Object methodsFor: 'message handling' stamp: 'di 3/26/1999 08:00'!
perform: selector withArguments: argArray inSuperclass: lookupClass
	"NOTE:  This is just like perform:withArguments:, except that
	the message lookup process begins, not with the receivers's class,
	but with the supplied superclass instead.  It will fail if lookupClass
	cannot be found among the receiver's superclasses.
	Primitive. Essential. See Object documentation whatIsAPrimitive."

	<primitive: 100>
	(selector isMemberOf: Symbol)
		ifFalse: [^ self error: 'selector argument must be a Symbol'].
	(selector numArgs = argArray size)
		ifFalse: [^ self error: 'incorrect number of arguments'].
	(self class == lookupClass or: [self class inheritsFrom: lookupClass])
		ifFalse: [^ self error: 'lookupClass is not in my inheritance chain'].
	self primitiveFailed! !

!Object methodsFor: 'objects from disk' stamp: 'tk 4/8/1999 12:46'!
comeFullyUpOnReload: smartRefStream
	"Normally this read-in object is exactly what we want to store. 7/26/96 tk"

	^ self! !

!Object methodsFor: 'objects from disk' stamp: 'RAA 12/20/2000 16:51'!
convertToCurrentVersion: varDict refStream: smartRefStrm

	"subclasses should implement if they wish to convert old instances to modern ones"! !

!Object methodsFor: 'objects from disk' stamp: 'RAA 1/10/2001 14:02'!
indexIfCompact

	^0		"helps avoid a #respondsTo: in publishing"! !

!Object methodsFor: 'objects from disk' stamp: 'tk 2/24/1999 11:08'!
objectForDataStream: refStrm
    "Return an object to store on an external data stream."

    ^ self! !

!Object methodsFor: 'objects from disk' stamp: 'tk 4/8/1999 12:05'!
readDataFrom: aDataStream size: varsOnDisk
	"Fill in the fields of self based on the contents of aDataStream.  Return self.
	 Read in the instance-variables written by Object>>storeDataOn:.
	 NOTE: This method must send beginReference: before reading any objects from aDataStream that might reference it.
	 Allow aDataStream to have fewer inst vars.  See SmartRefStream."
	| cntInstVars cntIndexedVars |

	cntInstVars _ self class instSize.
	self class isVariable
		ifTrue: [cntIndexedVars _ varsOnDisk - cntInstVars.
				cntIndexedVars < 0 ifTrue: [
					self error: 'Class has changed too much.  Define a convertxxx method']]
		ifFalse: [cntIndexedVars _ 0.
				cntInstVars _ varsOnDisk]. 	"OK if fewer than now"

	aDataStream beginReference: self.
	1 to: cntInstVars do:
		[:i | self instVarAt: i put: aDataStream next].
	1 to: cntIndexedVars do:
		[:i | self basicAt: i put: aDataStream next].
	"Total number read MUST be equal to varsOnDisk!!"
	^ self	"If we ever return something other than self, fix calls 
			on (super readDataFrom: aDataStream size: anInteger)"! !

!Object methodsFor: 'objects from disk' stamp: 'tk 6/26/97 13:48'!
saveOnFile
	"Ask the user for a filename and save myself on a SmartReferenceStream file.  Writes out the version and class structure.  The file is fileIn-able.  Does not file out the class of the object.  tk 6/26/97 13:48"

	| aFileName fileStream |
	aFileName _ self class name asFileName.	"do better?"
	aFileName _ FillInTheBlank request: 'File name?' initialAnswer: aFileName.
	aFileName size == 0 ifTrue: [^ self beep].

	fileStream _ FileStream newFileNamed: aFileName.
	fileStream fileOutClass: nil andObject: self.! !

!Object methodsFor: 'objects from disk' stamp: 'tk 8/9/2001 15:40'!
storeDataOn: aDataStream
	"Store myself on a DataStream.  Answer self.  This is a low-level DataStream/ReferenceStream method. See also objectToStoreOnDataStream.  NOTE: This method must send 'aDataStream beginInstance:size:' and then (nextPut:/nextPutWeak:) its subobjects.  readDataFrom:size: reads back what we write here."
	| cntInstVars cntIndexedVars |

	cntInstVars _ self class instSize.
	cntIndexedVars _ self basicSize.
	aDataStream
		beginInstance: self class
		size: cntInstVars + cntIndexedVars.
	1 to: cntInstVars do:
		[:i | aDataStream nextPut: (self instVarAt: i)].

	"Write fields of a variable length object.  When writing to a dummy 
		stream, don't bother to write the bytes"
	((aDataStream byteStream class == DummyStream) and: [self class isBits]) ifFalse: [
		1 to: cntIndexedVars do:
			[:i | aDataStream nextPut: (self basicAt: i)]].
! !

!Object methodsFor: 'printing' stamp: 'di 6/20/97 08:57'!
fullPrintString
	"Answer a String whose characters are a description of the receiver."

	^ String streamContents: [:s | self printOn: s]! !

!Object methodsFor: 'printing'!
isLiteral
	"Answer whether the receiver has a literal text form recognized by the 
	compiler."

	^false! !

!Object methodsFor: 'printing' stamp: 'sma 6/1/2000 09:28'!
longPrintOn: aStream
	"Append to the argument, aStream, the names and values of all 
	of the receiver's instance variables."

	self class allInstVarNames doWithIndex:
		[:title :index |
		aStream nextPutAll: title;
		 nextPut: $:;
		 space;
		 tab;
		 print: (self instVarAt: index);
		 cr]! !

!Object methodsFor: 'printing' stamp: 'tk 10/19/2001 11:18'!
longPrintOn: aStream limitedTo: sizeLimit indent: indent
	"Append to the argument, aStream, the names and values of all of the receiver's instance variables.  Limit is the length limit for each inst var."

	self class allInstVarNames doWithIndex:
		[:title :index |
		indent timesRepeat: [aStream tab].
		aStream nextPutAll: title;
		 nextPut: $:;
		 space;
		 tab;
		 nextPutAll: 
			((self instVarAt: index) printStringLimitedTo: (sizeLimit -3 -title size max: 1));
		 cr]! !

!Object methodsFor: 'printing' stamp: 'tk 10/16/2001 19:41'!
longPrintString
	"Answer a String whose characters are a description of the receiver."
	
	| str |
	str _ String streamContents: [:aStream | self longPrintOn: aStream].
	"Objects without inst vars should return something"
	^ str isEmpty ifTrue: [self printString, String cr] ifFalse: [str]! !

!Object methodsFor: 'printing' stamp: 'sw 3/7/2001 13:14'!
nominallyUnsent: aSelectorSymbol
	"From within the body of a method which is not formally sent within the system, but which you intend to have remain in the system (for potential manual invocation, or for documentation, or perhaps because it's sent by commented-out-code that you anticipate uncommenting out someday, send this message, with the selector itself as the argument.

This will serve two purposes:

	(1)  The method will not be returned by searches for unsent selectors (because it, in a manner of speaking, sends itself).
	(2)	You can locate all such methods by browsing senders of #nominallyUnsent:"

	false ifTrue: [self flag: #nominallyUnsent:]    "So that this method itself will appear to be sent"
! !

!Object methodsFor: 'printing' stamp: 'sma 6/1/2000 09:31'!
printOn: aStream
	"Append to the argument, aStream, a sequence of characters that  
	identifies the receiver."

	| title |
	title _ self class name.
	aStream
		nextPutAll: (title first isVowel ifTrue: ['an '] ifFalse: ['a ']);
		nextPutAll: title! !

!Object methodsFor: 'printing' stamp: 'sma 6/1/2000 09:22'!
printString
	"Answer a String whose characters are a description of the receiver. 
	If you want to print without a character limit, use fullPrintString."

	^ self printStringLimitedTo: 50000! !

!Object methodsFor: 'printing' stamp: 'tk 5/7/1999 16:20'!
printStringLimitedTo: limit
	"Answer a String whose characters are a description of the receiver.
	If you want to print without a character limit, use fullPrintString."
	| limitedString |
	limitedString _ String streamContents: [:s | self printOn: s] limitedTo: limit.
	limitedString size < limit ifTrue: [^ limitedString].
	^ limitedString , '...etc...'! !

!Object methodsFor: 'printing' stamp: 'MPW 1/1/1901 00:30'!
propertyList
	"Answer a String whose characters are a property-list description of the receiver."

	^ PropertyListEncoder process:self.
! !

!Object methodsFor: 'printing' stamp: 'sw 10/17/2000 11:16'!
reportableSize
	"Answer a string that reports the size of the receiver -- useful for showing in a list view, for example"

	^ (self basicSize + self class instSize) printString! !

!Object methodsFor: 'printing'!
storeOn: aStream 
	"Append to the argument aStream a sequence of characters that is an 
	expression whose evaluation creates an object similar to the receiver."

	aStream nextPut: $(.
	self class isVariable
		ifTrue: [aStream nextPutAll: '(', self class name, ' basicNew: ';
					store: self basicSize;
					nextPutAll: ') ']
		ifFalse: [aStream nextPutAll: self class name, ' basicNew'].
	1 to: self class instSize do:
		[:i |
		aStream nextPutAll: ' instVarAt: ';
			store: i;
			nextPutAll: ' put: ';
			store: (self instVarAt: i);
			nextPut: $;].
	1 to: self basicSize do:
		[:i |
		aStream nextPutAll: ' basicAt: ';
			store: i;
			nextPutAll: ' put: ';
			store: (self basicAt: i);
			nextPut: $;].
	aStream nextPutAll: ' yourself)'
! !

!Object methodsFor: 'printing' stamp: 'di 6/20/97 09:12'!
storeString
	"Answer a String representation of the receiver from which the receiver 
	can be reconstructed."

	^ String streamContents: [:s | self storeOn: s]! !

!Object methodsFor: 'printing' stamp: 'sw 5/2/1998 13:55'!
stringForReadout
	^ self stringRepresentation! !

!Object methodsFor: 'printing'!
stringRepresentation
	"Answer a string that represents the receiver.  For most objects this is simply its printString, but for strings themselves, it's themselves.  6/12/96 sw"

	^ self printString ! !

!Object methodsFor: 'scripting' stamp: 'ar 3/17/2001 20:11'!
adaptedToWorld: aWorld
	"If I refer to a world or a hand, return the corresponding items in the new world."
	^self! !

!Object methodsFor: 'scripting' stamp: 'RAA 3/5/2001 18:13'!
contentsGetz: x

	self contents: x! !

!Object methodsFor: 'scripting' stamp: 'sw 3/10/2000 13:57'!
defaultFloatPrecisionFor: aGetSelector
	"Answer a number indicating the default float precision to be used in a numeric readout for which the receiver is the model."

	^ 1! !

!Object methodsFor: 'scripting' stamp: 'RAA 3/9/2001 17:08'!
evaluateUnloggedForSelf: aCodeString

	^Compiler evaluate:
		aCodeString
		for: self
		logged: false! !

!Object methodsFor: 'scripting' stamp: 'sw 8/3/2001 22:02'!
methodInterfacesForCategory: aCategorySymbol inVocabulary: aVocabulary limitClass: aLimitClass
	"Return a list of methodInterfaces for the receiver in the given category, given a vocabulary.  aCategorySymbol is the inherent category symbol, not necessarily the wording as expressed in the vocabulary."

	| categorySymbol |
	categorySymbol _ aCategorySymbol asSymbol.

	(categorySymbol == #'instance variables') ifTrue:		"user-defined instance variables"
		[^ self methodInterfacesForInstanceVariablesCategoryIn: aVocabulary].

	(categorySymbol == #scripts) ifTrue:						"user-defined scripts"
		[^ self methodInterfacesForScriptsCategoryIn: aVocabulary].

	^ (self usableMethodInterfacesIn: (aVocabulary methodInterfacesInCategory: (aVocabulary translatedWordingFor: categorySymbol) forInstance: self ofClass: self class limitClass: aLimitClass))   "all others"! !

!Object methodsFor: 'scripting' stamp: 'sw 8/3/2001 13:54'!
methodInterfacesForInstanceVariablesCategoryIn: aVocabulary
	"Return a collection of methodInterfaces for the instance-variables category.  The vocabulary parameter, at present anyway, is not used.  And for non-players, the method is at present vacuous in any case"

	^  OrderedCollection new! !

!Object methodsFor: 'scripting' stamp: 'sw 8/3/2001 13:53'!
methodInterfacesForScriptsCategoryIn: aVocabulary
	"Answer a list of method interfaces for the category #scripts, as seen in a viewer or other tool.  The vocabulary argument is not presently used.  Also, at present, only Players really do anyting interesting here."

	^ OrderedCollection new! !

!Object methodsFor: 'scripting' stamp: 'RAA 2/16/2001 19:37'!
selfWrittenAsIll

	^self! !

!Object methodsFor: 'scripting' stamp: 'RAA 2/16/2001 19:38'!
selfWrittenAsIm

	^self! !

!Object methodsFor: 'scripting' stamp: 'RAA 2/16/2001 19:37'!
selfWrittenAsMe

	^self! !

!Object methodsFor: 'scripting' stamp: 'RAA 2/16/2001 19:37'!
selfWrittenAsMy

	^self! !

!Object methodsFor: 'scripting' stamp: 'RAA 2/16/2001 19:38'!
selfWrittenAsThis

	^self! !

!Object methodsFor: 'system primitives'!
asOop
	"Primitive. Answer a SmallInteger whose value is half of the receiver's 
	object pointer (interpreting object pointers as 16-bit signed quantities). 
	Fail if the receiver is a SmallInteger. Essential. See Object documentation 
	whatIsAPrimitive."

	<primitive: 75>
	self primitiveFailed! !

!Object methodsFor: 'system primitives' stamp: 'di 1/9/1999 15:19'!
becomeForward: otherObject 
	"Primitive. All variables in the entire system that used to point
	to the receiver now point to the argument.
	Fails if either argument is a SmallInteger."

	(Array with: self)
		elementsForwardIdentityTo:
			(Array with: otherObject)! !

!Object methodsFor: 'system primitives' stamp: 'sw 10/16/2000 10:59'!
className
	"Answer a string characterizing the receiver's class, for use in list views for example"

	^ self class name asString! !

!Object methodsFor: 'system primitives' stamp: 'sw 10/16/2000 11:04'!
creationStamp
	"Answer a string which reports the creation particulars of the receiver.  Intended perhaps for list views, but this is presently a feature not easily accessible"

	^ '<no creation stamp>'! !

!Object methodsFor: 'system primitives'!
instVarAt: index 
	"Primitive. Answer a fixed variable in an object. The numbering of the 
	variables corresponds to the named instance variables. Fail if the index 
	is not an Integer or is not the index of a fixed variable. Essential. See 
	Object documentation whatIsAPrimitive."

	<primitive: 73>
	"Access beyond fixed variables."
	^self basicAt: index - self class instSize		! !

!Object methodsFor: 'system primitives'!
instVarAt: anInteger put: anObject 
	"Primitive. Store a value into a fixed variable in the receiver. The 
	numbering of the variables corresponds to the named instance variables. 
	Fail if the index is not an Integer or is not the index of a fixed variable. 
	Answer the value stored as the result. Using this message violates the 
	principle that each object has sovereign control over the storing of 
	values into its instance variables. Essential. See Object documentation 
	whatIsAPrimitive."

	<primitive: 74>
	"Access beyond fixed fields"
	^self basicAt: anInteger - self class instSize put: anObject! !

!Object methodsFor: 'system primitives' stamp: 'sw 10/16/2000 11:09'!
instVarNamed: aString
	"Return the value of the instance variable in me with that name.  Slow and unclean, but very useful. "

	^ self instVarAt: (self class allInstVarNames indexOf: aString asString)


! !

!Object methodsFor: 'system primitives' stamp: 'sw 10/16/2000 11:10'!
instVarNamed: aString put: aValue
	"Store into the value of the instance variable in me of that name.  Slow and unclean, but very useful. "

	^ self instVarAt: (self class allInstVarNames indexOf: aString asString) put: aValue
! !

!Object methodsFor: 'system primitives' stamp: 'sw 10/17/2000 11:12'!
oopString
	"Answer a string that represents the oop of the receiver"

	^ self asOop printString! !

!Object methodsFor: 'system primitives' stamp: 'ar 3/2/2001 01:34'!
primitiveChangeClassTo: anObject
	"Primitive. Change the class of the receiver into the class of the argument given that the format of the receiver matches the format of the argument's class. Fail if receiver or argument are SmallIntegers, or the receiver is an instance of a compact class and the argument isn't, or when the argument's class is compact and the receiver isn't, or when the format of the receiver is different from the format of the argument's class, or when the arguments class is fixed and the receiver's size differs from the size that an instance of the argument's class should have.
	Note: The primitive will fail in most cases that you think might work. This is mostly because of a) the difference between compact and non-compact classes, and b) because of differences in the format. As an example, '(Array new: 3) primitiveChangeClassTo: Morph basicNew' would fail for three of the reasons mentioned above. Array is compact, Morph is not (failure #1). Array is variable and Morph is fixed (different format - failure #2). Morph is a fixed-field-only object and the array is too short (failure #3).
	The facility is really provided for certain, very specific applications (mostly related to classes changing shape) and not for casual use."

	<primitive: 115>
	self primitiveFailed! !

!Object methodsFor: 'system primitives' stamp: 'di 3/27/1999 12:21'!
rootStubInImageSegment: imageSegment

	^ ImageSegmentRootStub new
		xxSuperclass: nil
		format: nil
		segment: imageSegment! !

!Object methodsFor: 'system primitives'!
someObject
	"Primitive. Answer the first object in the enumeration of all
	 objects."

	<primitive: 138>
	self primitiveFailed.! !

!Object methodsFor: 'system primitives' stamp: 'ar 5/25/2000 20:27'!
tryNamedPrimitive
	"This method is a template that the Smalltalk simulator uses to 
	execute primitives. See Object documentation whatIsAPrimitive."
	<primitive:'' module:''>
	^ ContextPart primitiveFailToken! !

!Object methodsFor: 'system primitives' stamp: 'ar 5/25/2000 20:27'!
tryNamedPrimitive: arg1
	"This method is a template that the Smalltalk simulator uses to 
	execute primitives. See Object documentation whatIsAPrimitive."
	<primitive:'' module:''>
	^ ContextPart primitiveFailToken! !

!Object methodsFor: 'system primitives' stamp: 'ar 5/25/2000 20:27'!
tryNamedPrimitive: arg1 with: arg2
	"This method is a template that the Smalltalk simulator uses to 
	execute primitives. See Object documentation whatIsAPrimitive."
	<primitive:'' module:''>
	^ ContextPart primitiveFailToken! !

!Object methodsFor: 'system primitives' stamp: 'ar 5/25/2000 20:27'!
tryNamedPrimitive: arg1 with: arg2 with: arg3
	"This method is a template that the Smalltalk simulator uses to 
	execute primitives. See Object documentation whatIsAPrimitive."
	<primitive:'' module:''>
	^ ContextPart primitiveFailToken! !

!Object methodsFor: 'system primitives' stamp: 'ar 5/25/2000 20:27'!
tryNamedPrimitive: arg1 with: arg2 with: arg3 with: arg4
	"This method is a template that the Smalltalk simulator uses to 
	execute primitives. See Object documentation whatIsAPrimitive."
	<primitive:'' module:''>
	^ ContextPart primitiveFailToken! !

!Object methodsFor: 'system primitives' stamp: 'ar 5/25/2000 20:27'!
tryNamedPrimitive: arg1 with: arg2 with: arg3 with: arg4 with: arg5
	"This method is a template that the Smalltalk simulator uses to 
	execute primitives. See Object documentation whatIsAPrimitive."
	<primitive:'' module:''>
	^ ContextPart primitiveFailToken! !

!Object methodsFor: 'system primitives' stamp: 'ar 5/25/2000 20:27'!
tryNamedPrimitive: arg1 with: arg2 with: arg3 with: arg4 with: arg5 with: arg6
	"This method is a template that the Smalltalk simulator uses to 
	execute primitives. See Object documentation whatIsAPrimitive."
	<primitive:'' module:''>
	^ ContextPart primitiveFailToken! !

!Object methodsFor: 'system primitives' stamp: 'ar 5/25/2000 20:27'!
tryNamedPrimitive: arg1 with: arg2 with: arg3 with: arg4 with: arg5 with: arg6 with: arg7
	"This method is a template that the Smalltalk simulator uses to 
	execute primitives. See Object documentation whatIsAPrimitive."
	<primitive:'' module:''>
	^ ContextPart primitiveFailToken! !

!Object methodsFor: 'system primitives' stamp: 'ar 5/25/2000 20:27'!
tryNamedPrimitive: arg1 with: arg2 with: arg3 with: arg4 with: arg5 with: arg6 with: arg7 with: arg8
	"This method is a template that the Smalltalk simulator uses to 
	execute primitives. See Object documentation whatIsAPrimitive."
	<primitive:'' module:''>
	^ ContextPart primitiveFailToken! !

!Object methodsFor: 'system primitives' stamp: 'di 2/10/1999 22:16'!
tryPrimitive: primIndex withArgs: argumentArray
	"This method is a template that the Smalltalk simulator uses to 
	execute primitives. See Object documentation whatIsAPrimitive."

	<primitive: 118>
	^ ContextPart primitiveFailToken! !

!Object methodsFor: 'testing' stamp: 'sw 9/26/2001 11:58'!
basicType
	"Answer a symbol representing the inherent type of the receiver"

	^ #Object! !

!Object methodsFor: 'testing' stamp: 'sw 5/3/2001 16:19'!
beViewed
	"Open up a viewer on the receiver.  The Presenter is invited to decide just how to present this viewer"

	self uniqueNameForReference.  "So the viewer will have something nice to refer to"
	self presenter viewObject: self! !

!Object methodsFor: 'testing' stamp: 'sw 10/16/2000 11:01'!
costumes
	"Answer a list of costumes associated with the receiver.  The appearance of this method in class Object serves only as a backstop, probably only transitionally"

	^ nil! !

!Object methodsFor: 'testing' stamp: 'sw 1/12/98 18:09'!
haltIfNil! !

!Object methodsFor: 'testing' stamp: 'sw 1/30/2001 22:24'!
haveFullProtocolBrowsed
	"Open up a Lexicon on the receiver"

	^ self haveFullProtocolBrowsedShowingSelector: nil

	"(2@3) haveFullProtocolBrowsed"
! !

!Object methodsFor: 'testing' stamp: 'sw 3/20/2001 12:20'!
haveFullProtocolBrowsedShowingSelector: aSelector
	"Open up a Lexicon on the receiver, having it open up showing aSelector, which may be nil"

	| aBrowser |
	aBrowser _ InstanceBrowser new useVocabulary: Vocabulary fullVocabulary.
	aBrowser openOnObject: self inWorld: ActiveWorld showingSelector: aSelector

	"(2@3) haveFullProtocolBrowsed"! !

!Object methodsFor: 'testing' stamp: 'ar 7/9/1999 18:18'!
isBehavior
	"Return true if the receiver is a behavior.
	Note: Do not override in any class except behavior."
	^false! !

!Object methodsFor: 'testing' stamp: 'ar 8/17/1999 19:43'!
isCollection
	"Return true if the receiver is some sort of Collection and responds to basic collection messages such as #size and #do:"
	^false! !

!Object methodsFor: 'testing'!
isColor
	"Answer true if receiver is a Color. False by default."

	^ false
! !

!Object methodsFor: 'testing' stamp: 'di 11/9/1998 09:38'!
isFloat
	"Overridden to return true in Float, natch"
	^ false! !

!Object methodsFor: 'testing' stamp: 'ar 10/30/2000 23:22'!
isForm
	^false! !

!Object methodsFor: 'testing' stamp: 'len 1/13/98 21:18'!
isFraction
	"Answer true if the receiver is a Fraction."

	^ false! !

!Object methodsFor: 'testing'!
isInteger
	"Overridden to return true in Integer."

	^ false! !

!Object methodsFor: 'testing'!
isMorph

	^ false! !

!Object methodsFor: 'testing' stamp: 'ar 9/13/2000 15:37'!
isMorphicEvent
	^false! !

!Object methodsFor: 'testing'!
isNumber
	"Overridden to return true in Number, natch"
	^ false! !

!Object methodsFor: 'testing' stamp: 'di 11/6/1998 08:04'!
isPoint
	"Overridden to return true in Point."

	^ false! !

!Object methodsFor: 'testing' stamp: 'ikp 9/26/97 14:45'!
isPseudoContext
	^false! !

!Object methodsFor: 'testing' stamp: 'ar 12/23/1999 15:43'!
isStream
	"Return true if the receiver responds to the stream protocol"
	^false
! !

!Object methodsFor: 'testing' stamp: 'sma 6/15/2000 15:48'!
isString
	"Overridden to return true in String, natch"
	^ false! !

!Object methodsFor: 'testing'!
isText
	^ false! !

!Object methodsFor: 'testing' stamp: 'tk 10/21/97 12:45'!
isTransparent
	^ false! !

!Object methodsFor: 'testing' stamp: 'ar 8/14/2001 23:19'!
isVariableBinding
	"Return true if I represent a literal variable binding"
	^false
	! !

!Object methodsFor: 'testing' stamp: 'ls 7/14/1998 21:45'!
isWebBrowser
	"whether this object is a web browser.  See class: Scamper"
	^false! !

!Object methodsFor: 'testing' stamp: 'sw 10/27/2000 06:58'!
knownName
	"If a formal name has been handed out for this object, answer it, else nil"
	
	^ Preferences capitalizedReferences
		ifTrue:
			[References keyAtValue: self ifAbsent: [nil]]
		ifFalse:
			[nil]! !

!Object methodsFor: 'testing' stamp: 'sw 9/27/96'!
name
	"Answer a name for the receiver.  This is used generically in the title of certain inspectors, such as the referred-to inspector, and specificially by various subsystems.  By default, we let the object just print itself out..  "

	^ self printString! !

!Object methodsFor: 'testing' stamp: 'sw 11/19/2001 13:28'!
nameForViewer
	"Answer a name to be shown in a Viewer that is viewing the receiver"

	| aName |
	(aName _ self uniqueNameForReferenceOrNil) ifNotNil: [^ aName].
	(aName _ self knownName) ifNotNil: [^ aName].

	^ [(self asString copyWithout: Character cr) truncateTo:  27] ifError:
		[:msg :rcvr | ^ self class name printString]! !

!Object methodsFor: 'testing'!
notNil
	"Coerces nil to false and everything else to true."

	^true! !

!Object methodsFor: 'testing' stamp: 'tk 9/6/2001 19:15'!
openInstanceBrowserWithTiles
	"Open up an instance browser on me with tiles as the code type, and with the search level as desired."

	| aBrowser |
	aBrowser _ InstanceBrowser new.
	aBrowser useVocabulary: Vocabulary fullVocabulary.
	aBrowser limitClass: self class.
	aBrowser contentsSymbol: #tiles.		"preset it to make extra buttons (tile menus)"
	aBrowser openOnObject: self inWorld: ActiveWorld showingSelector: nil.
	aBrowser contentsSymbol: #source.
	aBrowser toggleShowingTiles.

	"
(2@3) openInstanceBrowserWithTiles.
WatchMorph new openInstanceBrowserWithTiles
"! !

!Object methodsFor: 'testing' stamp: 'sw 2/27/2002 14:55'!
renameTo: newName
	"If the receiver has an inherent idea about its own name, it should take action here.  Any object that might be pointed to in the References dictionary might get this message sent to it upon reload"! !

!Object methodsFor: 'testing' stamp: 'sw 1/18/2001 13:43'!
showDiffs
	"Answer whether the receiver, serving as the model of a text-bearing entity, is 'showing differences' -- if it is, the editor may wish to show special feedback"

	^ false! !

!Object methodsFor: 'testing' stamp: 'sw 10/20/1999 14:52'!
stepAt: millisecondClockValue in: aWindow

	^ self stepIn: aWindow! !

!Object methodsFor: 'testing' stamp: 'sw 10/19/1999 08:16'!
stepIn: aWindow

	^ self step! !

!Object methodsFor: 'testing' stamp: 'sw 10/19/1999 08:21'!
stepTime
	
	^ 1000 "milliseconds -- default backstop for objects serving as models of system windows"! !

!Object methodsFor: 'testing' stamp: 'sw 10/19/1999 08:22'!
stepTimeIn: aSystemWindow
	
	^ 1000 "milliseconds -- default backstop for objects serving as models of system windows"! !

!Object methodsFor: 'testing' stamp: 'sw 5/3/2001 18:22'!
vocabularyDemanded
	"Answer a vocabulary that the receiver insists be used when it is looked at in a Viewer.  This allows specific classes to insist on specific custom vocabularies"

	^ nil! !

!Object methodsFor: 'testing' stamp: 'sw 11/13/2001 07:26'!
wantsDiffFeedback
	"Answer whether the receiver, serving as the model of a text-bearing entity, would like for 'diffs' green pane-border feedback to be shown"

	^ false! !

!Object methodsFor: 'testing' stamp: 'di 1/8/1999 15:04'!
wantsSteps
	"Overridden by morphic classes whose instances want to be stepped,
	or by model classes who want their morphic views to be stepped."

	^ false! !

!Object methodsFor: 'testing' stamp: 'sw 10/19/1999 08:26'!
wantsStepsIn: aSystemWindow
	
	^ self wantsSteps! !

!Object methodsFor: 'translation support' stamp: 'acg 9/19/1999 20:39'!
asIf: aClass var: aString

	|index|
	index _ aClass allInstVarNames 
		indexOf: aString
		ifAbsent: [self error: 'must use instVar name'].
	^self instVarAt: index
! !

!Object methodsFor: 'translation support' stamp: 'acg 10/5/1999 06:35'!
asIf: aClass var: aString asValue: someClass

	^(self asIf: aClass var: aString) asValue: someClass
! !

!Object methodsFor: 'translation support' stamp: 'acg 9/19/1999 20:40'!
asIf: aClass var: aString put: aValue

	|index|
	index _ aClass allInstVarNames 
		indexOf: aString
		ifAbsent: [self error: 'must use instVar name'].
	^self instVarAt: index put: aValue
! !

!Object methodsFor: 'translation support' stamp: 'acg 9/20/1999 11:30'!
asOop: aClass

	(self class isVariable and: [self class instSize > 0])
		ifTrue: [self error: 'cannot auto-coerce indexable objects with named instance variables'].
	(aClass ccgCanConvertFrom: self)
		ifFalse: [self error: 'incompatible object for this coercion'].
	^self! !

!Object methodsFor: 'translation support' stamp: 'acg 9/19/1999 20:21'!
asSmallIntegerObj

	^self! !

!Object methodsFor: 'translation support' stamp: 'acg 10/5/1999 06:21'!
asValue: aClass

	^self! !

!Object methodsFor: 'translation support'!
cCode: codeString
	"For translation only; noop when running in Smalltalk."! !

!Object methodsFor: 'translation support' stamp: 'jm 2/15/1999 13:11'!
cCode: codeString inSmalltalk: aBlock
	"Support for Smalltalk-to-C translation. The given string is output literally when generating C code. If this code is being simulated in Smalltalk, answer the result of evaluating the given block."

	^ aBlock value
! !

!Object methodsFor: 'translation support'!
cCoerce: value to: cType
	"Type coercion for translation only; just return the value when running in Smalltalk."

	^ value! !

!Object methodsFor: 'translation support' stamp: 'ar 9/18/1998 23:27'!
export: aBoolean
	"For translation only; noop when running in Smalltalk."! !

!Object methodsFor: 'translation support'!
inline: inlineFlag
	"For translation only; noop when running in Smalltalk."! !

!Object methodsFor: 'translation support' stamp: 'acg 9/19/1999 11:51'!
primitive: primID parameters: parmSpecs receiver: rcvrSpec

	| tMethod |
	tMethod _ TestTMethod new 
		fromContext: thisContext sender 
		primitive: primID 
		parameters: parmSpecs 
		receiver: rcvrSpec.
	^tMethod simulatePrologInContext: thisContext sender! !

!Object methodsFor: 'translation support' stamp: 'acg 1/1/2000 12:45'!
remapOop: oopOrList in: aBlock
	"For translation only; noop when running in Smalltalk."
	^aBlock value! !

!Object methodsFor: 'translation support'!
returnTypeC: typeString
	"For translation only; noop when running in Smalltalk."! !

!Object methodsFor: 'translation support'!
sharedCodeNamed: label inCase: caseNumber
	"For translation only; noop when running in Smalltalk."! !

!Object methodsFor: 'translation support' stamp: 'acg 1/1/2000 12:46'!
stAt: index

	^self at: index! !

!Object methodsFor: 'translation support' stamp: 'acg 1/1/2000 12:46'!
stAt: index put: value

	^self at: index put: value! !

!Object methodsFor: 'translation support' stamp: 'acg 1/1/2000 22:42'!
stSize

	^self size! !

!Object methodsFor: 'translation support' stamp: 'ar 2/21/2000 00:42'!
static: aBoolean
	"For translation only; noop when running in Smalltalk."! !

!Object methodsFor: 'translation support' stamp: 'acg 12/18/1999 11:31'!
suppressFailureGuards: failureGuardFlag
	"For translation only; noop when running in Smalltalk."! !

!Object methodsFor: 'translation support'!
var: varSymbol declareC: declString
	"For translation only; noop when running in Smalltalk."! !

!Object methodsFor: 'translation support' stamp: 'sma 3/3/2000 12:06'!
var: varSymbol type: typeString
	"For translation only; noop when running in Smalltalk."! !

!Object methodsFor: 'translation support' stamp: 'sma 3/3/2000 12:06'!
var: varSymbol type: typeString array: array
	"For translation only; noop when running in Smalltalk."! !

!Object methodsFor: 'undo' stamp: 'di 9/11/2000 20:32'!
capturedState
	"May be overridden in subclasses."

	^ self shallowCopy
! !

!Object methodsFor: 'undo' stamp: 'di 9/11/2000 20:29'!
commandHistory
	"Return the command history for the receiver"
	| w |
	(w _ self currentWorld) ifNotNil: [^ w commandHistory].
	^ CommandHistory new. "won't really record anything but prevent breaking things"! !

!Object methodsFor: 'undo' stamp: 'di 12/12/2000 15:01'!
purgeAllCommands
	"Purge all commands for this object"
	Preferences useUndo ifFalse: [^ self]. "get out quickly"
	self commandHistory purgeAllCommandsSuchThat: [:cmd | cmd undoTarget == self].
! !

!Object methodsFor: 'undo' stamp: 'di 9/12/2000 08:15'!
redoFromCapturedState: st 
	"May be overridden in subclasses.  See also capturedState"

	self undoFromCapturedState: st  "Simple cases are symmetric"
! !

!Object methodsFor: 'undo' stamp: 'sw 11/16/2000 14:42'!
refineRedoTarget: target selector: aSymbol arguments: arguments in: refineBlock 
	"Any object can override this method to refine its redo specification"

	^ refineBlock
		value: target
		value: aSymbol
		value: arguments! !

!Object methodsFor: 'undo' stamp: 'sw 11/16/2000 14:42'!
refineUndoTarget: target selector: aSymbol arguments: arguments in: refineBlock 
	"Any object can override this method to refine its undo specification"

	^ refineBlock
		value: target
		value: aSymbol
		value: arguments! !

!Object methodsFor: 'undo' stamp: 'di 9/11/2000 20:30'!
rememberCommand: aCommand
	"Remember the given command for undo"
	Preferences useUndo ifFalse: [^ self]. "get out quickly"
	^ self commandHistory rememberCommand: aCommand! !

!Object methodsFor: 'undo' stamp: 'di 9/11/2000 20:30'!
rememberUndoableAction: actionBlock named: caption
	| cmd result |
	cmd _ Command new cmdWording: caption.
	cmd undoTarget: self selector: #undoFromCapturedState: argument: self capturedState.
	result _ actionBlock value.
	cmd redoTarget: self selector: #redoFromCapturedState: argument: self capturedState.
	self rememberCommand: cmd.
	^ result! !

!Object methodsFor: 'undo' stamp: 'di 9/11/2000 20:32'!
undoFromCapturedState: st 
	"May be overridden in subclasses.  See also capturedState"

	self copyFrom: st
! !

!Object methodsFor: 'updating'!
changed
	"Receiver changed in a general way; inform all the dependents by 
	sending each dependent an update: message."

	self changed: self! !

!Object methodsFor: 'updating'!
changed: aParameter 
	"Receiver changed. The change is denoted by the argument aParameter. 
	Usually the argument is a Symbol that is part of the dependent's change 
	protocol. Inform all of the dependents."

	self dependents do: [:aDependent | aDependent update: aParameter]! !

!Object methodsFor: 'updating' stamp: 'sw 10/12/1999 18:15'!
handledListVerification
	"When a self-updating PluggableListMorph lazily checks to see the state of affairs, it first gives its model an opportunity to handle the list verification itself (this is appropriate for some models, such as VersionsBrowser); if a list's model has indeed handled things itself, it returns true here"

	^ false! !

!Object methodsFor: 'updating' stamp: 'sw 10/31/1999 00:15'!
noteSelectionIndex: anInteger for: aSymbol
	"backstop"! !

!Object methodsFor: 'updating'!
okToChange
	"Allows a controller to ask this of any model"
	^ true! !

!Object methodsFor: 'updating' stamp: 'sma 2/29/2000 20:05'!
update: aParameter 
	"Receive a change notice from an object of whom the receiver is a 
	dependent. The default behavior is to do nothing; a subclass might want 
	to change itself in some way."

	^ self! !

!Object methodsFor: 'updating' stamp: 'sw 10/19/1999 14:39'!
updateListsAndCodeIn: aWindow
	self canDiscardEdits ifFalse: [^ self].
	aWindow updatablePanes do: [:aPane | aPane verifyContents]! !

!Object methodsFor: 'updating' stamp: 'jm 8/20/1998 18:26'!
windowIsClosing
	"This message is used to inform a models that its window is closing. Most models do nothing, but some, such as the Debugger, must do some cleanup. Note that this mechanism must be used with care by models that support multiple views, since one view may be closed while others left open."
! !

!Object methodsFor: 'user interface' stamp: 'sw 10/4/1999 08:13'!
addModelItemsToWindowMenu: aMenu
	"aMenu is being constructed to be presented to the user in response to the user's pressing on the menu widget in the title bar of a morphic window.  Here, the model is given the opportunity to add any model-specific items to the menu, whose default target is the SystemWindow itself."! !

!Object methodsFor: 'user interface' stamp: 'sw 10/5/1998 14:39'!
addModelMenuItemsTo: aCustomMenu forMorph: aMorph hand: aHandMorph 
	"The receiver serves as the model for aMorph; a menu is being constructed for the morph, and here the receiver is able to add its own items"
! !

!Object methodsFor: 'user interface' stamp: 'sma 11/12/2000 11:43'!
asExplorerString
	^ self printString! !

!Object methodsFor: 'user interface'!
basicInspect
	"Create and schedule an Inspector in which the user can examine the 
	receiver's variables. This method should not be overriden."

	Inspector openOn: self withEvalPane: false! !

!Object methodsFor: 'user interface'!
beep
	"Make a beep sound.  Every object would like to be able to speak.  6/10/96 sw"

	Smalltalk beep! !

!Object methodsFor: 'user interface' stamp: 'sw 5/8/2000 01:59'!
browseHierarchy

	^ HierarchyBrowser newFor: self class

"(2@7) browseHierarchy"! !

!Object methodsFor: 'user interface' stamp: 'sw 7/13/1999 15:53'!
defaultBackgroundColor
	"Answer the color to be used as the base window color for a window whose model is an object of the receiver's class"
	
	^ Preferences windowColorFor: self class name! !

!Object methodsFor: 'user interface'!
defaultLabelForInspector
	"Answer the default label to be used for an Inspector window on the receiver."

	^ self class name! !

!Object methodsFor: 'user interface' stamp: 'RAA 7/10/2000 08:11'!
eToyStreamedRepresentationNotifying: aWidget

	| outData |
	[ outData _ SmartRefStream streamedRepresentationOf: self ] 
		on: ProgressInitiationException
		do: [ :ex | 
			ex sendNotificationsTo: [ :min :max :curr |
				aWidget ifNotNil: [aWidget flashIndicator: #working].
			].
		].
	^outData
! !

!Object methodsFor: 'user interface' stamp: 'RAA 6/21/1999 15:32'!
explore

	^ObjectExplorer new openExplorerFor: self! !

!Object methodsFor: 'user interface' stamp: 'sw 8/15/97 17:25'!
fullScreenSize
	"Answer the size to which a window displaying the receiver should be set"
	| adj |
	adj _ (3 * Preferences scrollBarWidth) @ 0.
	^ Rectangle origin: adj extent: (DisplayScreen actualScreenSize - adj)! !

!Object methodsFor: 'user interface' stamp: 'RAA 6/21/1999 11:27'!
hasContentsInExplorer

	^self basicSize > 0 or: [self class allInstVarNames isEmpty not]
! !

!Object methodsFor: 'user interface' stamp: 'sma 5/28/2000 15:59'!
inform: aString
	"Display a message for the user to read and then dismiss. 6/9/96 sw"

	aString isEmptyOrNil ifFalse: [PopUpMenu inform: aString]! !

!Object methodsFor: 'user interface'!
initialExtent
	"Answer the desired extent for the receiver when a view on it is first opened on the screen. 
	5/22/96 sw: in the absence of any override, obtain from RealEstateAgent"

	^ RealEstateAgent standardWindowExtent! !

!Object methodsFor: 'user interface' stamp: 'di 5/19/1998 20:43'!
inspect
	"Create and schedule an Inspector in which the user can examine the receiver's variables."

	Inspector openOn: self withEvalPane: true! !

!Object methodsFor: 'user interface'!
inspectWithLabel: aLabel
	Inspector openOn: self withEvalPane: true withLabel: aLabel! !

!Object methodsFor: 'user interface' stamp: 'sw 6/12/2001 11:09'!
launchPartVia: aSelector
	"Obtain a morph by sending aSelector to self, and attach it to the morphic hand.  This provides a general protocol for parts bins"

	| aMorph |
	aMorph _ self perform: aSelector.
	aMorph setProperty: #beFullyVisibleAfterDrop toValue: true.
	aMorph openInHand! !

!Object methodsFor: 'user interface' stamp: 'ar 12/14/2001 20:08'!
launchPartVia: aSelector label: aString
	"Obtain a morph by sending aSelector to self, and attach it to the morphic hand.  This provides a general protocol for parts bins"

	| aMorph |
	aMorph _ self perform: aSelector.
	aMorph setNameTo: aString.
	aMorph setProperty: #beFullyVisibleAfterDrop toValue: true.
	aMorph openInHand! !

!Object methodsFor: 'user interface' stamp: 'sw 10/16/2000 11:11'!
launchTileToRefer
	"Create a tile to reference the receiver, and attach it to the hand"

	self currentHand attachMorph: self tileToRefer! !

!Object methodsFor: 'user interface' stamp: 'di 5/11/1999 22:26'!
modelSleep
	"A window with me as model is being exited or collapsed or closed.
	Default response is no-op" ! !

!Object methodsFor: 'user interface' stamp: 'di 5/11/1999 22:01'!
modelWakeUp
	"A window with me as model is being entered or expanded.  Default response is no-op" ! !

!Object methodsFor: 'user interface' stamp: 'sw 10/16/1999 22:45'!
modelWakeUpIn: aWindow
	"A window with me as model is being entered or expanded.  Default response is no-op" 
	self modelWakeUp! !

!Object methodsFor: 'user interface' stamp: 'sw 3/8/1999 15:27'!
mouseUpBalk: evt
	"A button I own got a mouseDown, but the user moved out before letting up.  Certain kinds of objects (so-called 'radio buttons', for example, and other structures that must always have some selection, e.g. PaintBoxMorph) wish to take special action in this case; this default does nothing."
! !

!Object methodsFor: 'user interface' stamp: 'sw 8/22/97 13:14'!
newTileMorphRepresentative
	^ TileMorph new setLiteral: self! !

!Object methodsFor: 'user interface' stamp: 'jcg 11/1/2001 13:13'!
notYetImplemented
	self inform: 'Not yet implemented (', thisContext sender printString, ')'! !

!Object methodsFor: 'user interface' stamp: 'di 6/10/1998 15:06'!
windowActiveOnFirstClick
	"Return true if my window should be active on first click."

	^ false! !

!Object methodsFor: 'user interface' stamp: 'di 6/10/1998 15:06'!
windowReqNewLabel: labelString
	"My window's title has been edited.
	Return true if this is OK, and override for further behavior."

	^ true! !

!Object methodsFor: 'viewer' stamp: 'sw 10/16/2000 10:35'!
assureUniClass
	"If the receiver is not yet an instance of a uniclass, create a uniclass for it and make the receiver become an instance of that class."

	| anInstance |
	self belongsToUniClass ifTrue: [^ self].
	anInstance _ self class instanceOfUniqueClass.
	self become: (self as: anInstance class).
	^ anInstance! !

!Object methodsFor: 'viewer' stamp: 'sw 10/16/2000 10:41'!
belongsToUniClass
	"Answer whether the receiver belongs to a uniclass.  For the moment (this is not entirely satisfactory) this is precisely equated with the classname ending in a digit"

	^ self class name endsWithDigit! !

!Object methodsFor: 'viewer' stamp: 'sw 12/11/2000 15:37'!
browseOwnClassSubProtocol
	"Open up a ProtocolBrowser on the subprotocol of the receiver"

	ProtocolBrowser openSubProtocolForClass: self class
! !

!Object methodsFor: 'viewer' stamp: 'sw 8/4/2001 00:51'!
categoriesForViewer: aViewer
	"Answer a list of categories to offer in the given viewer"

	^ aViewer currentVocabulary categoryListForInstance: self ofClass: self class limitClass: aViewer limitClass! !

!Object methodsFor: 'viewer' stamp: 'sw 8/3/2001 22:08'!
categoriesForVocabulary: aVocabulary limitClass: aLimitClass
	"Answer a list of categories of methods for the receiver when using the given vocabulary, given that one considers only methods that are implemented not further away than aLimitClass"

	^ aVocabulary categoryListForInstance: self ofClass: self class limitClass: aLimitClass! !

!Object methodsFor: 'viewer' stamp: 'sw 10/25/2000 07:20'!
chooseNewNameForReference
	"Offer an opportunity for the receiver, presumed already to be known in the References registry, to be renamed"

	|  nameSym current newName |
	current _ References keyAtValue: self ifAbsent: [^ self error: 'not found in References'].

	newName _ FillInTheBlank request: 'Please enter new name' initialAnswer: current.
	"Want to user some better way of determining the validity of the chosen identifier, and also want to give more precise diagnostic if the string the user types in is not acceptable.  Work to be done here."

	newName isEmpty ifTrue: [^ nil].
	((Scanner isLiteralSymbol: newName) and: [(newName includes: $:) not])
		ifTrue:
			[nameSym _ newName capitalized asSymbol.
			(((References includesKey:  nameSym) not and:
				[(Smalltalk includesKey: nameSym) not]) and:
						[(ScriptingSystem allKnownClassVariableNames includes: nameSym) not])
					ifTrue:
						[(References associationAt: current) key: nameSym.
						References rehash.
						^ nameSym]].
	self inform: 'Sorry, that name is not available.'.
	^ nil! !

!Object methodsFor: 'viewer' stamp: 'sw 8/3/2001 21:22'!
defaultLimitClassForVocabulary: aVocabulary
	"Answer the class to use, by default, as the limit class on a protocol browser or viewer opened up on the receiver, within the purview of the Vocabulary provided"

	^ (aVocabulary isKindOf: FullVocabulary)
		ifTrue:
			 [self class superclass == Object
				ifTrue:
					[self class]
				ifFalse:
					[self class superclass]]
		ifFalse:
			[ProtoObject]! !

!Object methodsFor: 'viewer' stamp: 'sw 2/14/2000 14:24'!
defaultNameStemForInstances
	"Answer a basis for names of default instances of the receiver.  The default is to let the class specify, but certain instances will want to override.  (PasteUpMorphs serving as Worlds come to mind"

	^ self class defaultNameStemForInstances! !

!Object methodsFor: 'viewer' stamp: 'sw 5/22/2001 16:53'!
elementTypeFor: aStringOrSymbol vocabulary: aVocabulary
	"Answer a symbol characterizing what kind of element aStringOrSymbol represents.  Realistically, at present, this always just returns #systemScript; a prototyped but not-incorporated architecture supported use of a leading colon to characterize an inst var of a system class, and for the moment we still see its remnant here."

	self flag: #deferred.  "a loose end in the non-player case"
	^ #systemScript! !

!Object methodsFor: 'viewer' stamp: 'sw 5/4/2001 07:04'!
externalName
	"Answer an external name by which the receiver is known.  Generic implementation here is a transitional backstop. probably"

	^ self nameForViewer! !

!Object methodsFor: 'viewer' stamp: 'sw 5/4/2001 07:06'!
graphicForViewerTab
	"When a Viewer is open on the receiver, its tab needs some graphic to show to the user.  Answer a form or a morph to serve that purpose.  A generic image is used for arbitrary objects, but note my reimplementors"
	
	^ ScriptingSystem formAtKey: 'Image'! !

!Object methodsFor: 'viewer' stamp: 'sw 5/4/2001 07:08'!
hasUserDefinedSlots
	"Answer whether the receiver has any user-defined slots, in the omniuser sense of the term.  This is needed to allow Viewers to look at any object, not just at Players."

	^ false! !

!Object methodsFor: 'viewer' stamp: 'sw 5/22/2001 12:31'!
infoFor: anElement inViewer: aViewer
	"The user made a gesture asking for info/menu relating to me.  Some of the messages dispatched here are not yet available in this image"

	| aMenu elementType |
	elementType _ self elementTypeFor: anElement vocabulary: aViewer currentVocabulary.
	((elementType = #systemSlot) | (elementType == #userSlot))
		ifTrue:	[^ self slotInfoButtonHitFor: anElement inViewer: aViewer].
	self flag: #deferred.  "Use a traditional MenuMorph, and reinstate the pacify thing"
	aMenu _ MenuMorph new defaultTarget: aViewer.
	#(	('implementors'			browseImplementorsOf:)
		('senders'				browseSendersOf:)
		('versions'				browseVersionsOf:)
		-
		('browse full'			browseMethodFull:)
		('inheritance'			browseMethodInheritance:)
		-
		('about this method'		aboutMethod:)) do:

			[:pair |
				pair = '-'
					ifTrue:
						[aMenu addLine]
					ifFalse:
						[aMenu add: pair first target: aViewer selector: pair second argument: anElement]].
	aMenu addLine.
	aMenu defaultTarget: self.
	#(	('destroy script'		removeScript:)
		('rename script'		renameScript:)
		('pacify script'		pacifyScript:)) do:
			[:pair |
				aMenu add: pair first target: self selector: pair second argument: anElement].

	aMenu items size == 0 ifTrue:
		[aMenu add: 'ok' action: nil].  "in case it was a slot -- weird, transitional"

	aMenu addTitle: anElement asString, ' (', elementType, ')'.

	aMenu popUpInWorld: self currentWorld.
 ! !

!Object methodsFor: 'viewer' stamp: 'sw 9/26/2001 11:58'!
initialTypeForSlotNamed: aName
	"Answer the initial type to be ascribed to the given instance variable"

	^ #Object! !

!Object methodsFor: 'viewer' stamp: 'ar 5/26/2001 16:13'!
isPlayerLike
	"Return true if the receiver is a player-like object"
	^false! !

!Object methodsFor: 'viewer' stamp: 'sw 11/12/2001 13:47'!
methodInterfacesInPresentationOrderFrom: interfaceList forCategory: aCategory
	"Answer the interface list sorted in desired presentation order, using a static master-ordering list, q.v.  The category parameter allows an escape in case one wants to apply different order strategies in different categories, but for now a single master-priority-ordering is used -- see the comment in method EToyVocabulary.masterOrderingOfPhraseSymbols"

	| masterOrder interfaces firstIndex secondIndex |
	masterOrder _ Vocabulary eToyVocabulary masterOrderingOfPhraseSymbols.
	interfaces _ interfaceList asSortedCollection:
		[:a :b |
			firstIndex _ masterOrder indexOf: a elementSymbol.
			secondIndex _ masterOrder indexOf: b elementSymbol.
			firstIndex > 0
				ifTrue:
					[secondIndex = 0 or: [secondIndex > firstIndex]]
				ifFalse:
					[secondIndex ==  0 or: [b elementSymbol < a elementSymbol]]].
	^ interfaces asArray
! !

!Object methodsFor: 'viewer' stamp: 'sw 10/24/2000 11:36'!
newScriptorAround: aPhraseTileMorph
	"Sprout a scriptor around aPhraseTileMorph, thus making a new script.  This is where generalized scriptors will be threaded in"

	^ nil! !

!Object methodsFor: 'viewer' stamp: 'sw 8/3/2001 18:19'!
offerViewerMenuFor: aViewer event: evt
	"Offer the primary Viewer menu to the user.  Copied up from Player code, but most of the functions suggested here don't work for non-Player objects, many aren't even defined, some relate to exploratory sw work not yet reflected in the current corpus.  We are early in the life cycle of this method..."

	| aMenu |
	aMenu _ MenuMorph new defaultTarget: self.
	aMenu addStayUpItem.
	aMenu title: '**CAUTION -- UNDER CONSTRUCTION!!**
Many things may not work!!
', self nameForViewer.
	(aViewer affordsUniclass and: [self belongsToUniClass not]) ifTrue:
		[aMenu add: 'give me a Uniclass' action: #assureUniClass.
		aMenu addLine].
	aMenu add: 'choose vocabulary...' target: aViewer action: #chooseVocabulary.
	aMenu add: 'choose limit class...' target: aViewer action: #chooseLimitClass.
	aMenu balloonTextForLastItem: 'Specify which class should be the most generic one to have its methods shown in this Viewer'.
	aMenu addLine.

	self belongsToUniClass ifTrue:
		[aMenu add: 'add a new instance variable' target: self selector: #addInstanceVariableIn: argument: aViewer.
		aMenu add: 'add a new script' target: aViewer selector: #newPermanentScriptIn: argument: aViewer.
		aMenu addLine.
		aMenu add: 'make my class be first-class' target: self selector: #makeFirstClassClassIn: argument: aViewer.
		aMenu add: 'move my changes up to my superclass' target: self action: #promoteChangesToSuperclass.
		aMenu addLine].

	aMenu add: 'tear off a tile' target: self selector: #launchTileToRefer.
	aMenu addLine.

	aMenu add: 'inspect me' target: self selector: #inspect.
	aMenu add: 'inspect my class' target: self class action: #inspect.
	aMenu addLine.

	aMenu add: 'browse vocabulary' action: #haveFullProtocolBrowsed.
	aMenu add: 'inspect this Viewer' target: aViewer action: #inspect.

	aMenu popUpEvent: evt in: aViewer currentWorld

"
	aMenu add: 'references to me' target: aViewer action: #browseReferencesToObject.
	aMenu add: 'toggle scratch pane' target: aViewer selector: #toggleScratchPane.
	aMenu add: 'make a nascent script for me' target: aViewer selector: #makeNascentScript.
	aMenu add: 'rename me' target: aViewer selector: #chooseNewNameForReference.
	aMenu add: 'browse full' action: #browseOwnClassFull.
	aMenu add: 'browse hierarchy' action: #browseOwnClassHierarchy.
	aMenu add: 'set user level...' target: aViewer action: #setUserLevel.
	aMenu add: 'browse sub-protocol' action: #browseOwnClassSubProtocol.
	aMenu addLine.

"! !

!Object methodsFor: 'viewer' stamp: 'sw 10/25/2000 17:42'!
offerViewerMenuForEvt: anEvent morph: aMorph
	"Offer the viewer's primary menu to the user.  aMorph is some morph within the viewer itself, the one within which a mousedown triggered the need for this menu, and it is used only to retrieve the Viewer itself"

	self offerViewerMenuFor: (aMorph ownerThatIsA: StandardViewer) event: anEvent! !

!Object methodsFor: 'viewer' stamp: 'sw 1/22/2001 15:20'!
renameScript: oldSelector
	"prompt the user for a new selector and apply it.  Presently only works for players"

	self notYetImplemented! !

!Object methodsFor: 'viewer' stamp: 'sw 11/13/2001 09:37'!
tilePhrasesForCategory: aCategorySymbol inViewer: aViewer
	"Return a collection of phrases for the category.  If using classic tiles, only include phrases that have fewer than two arguments, because all that they can handle."

	| interfaces itsSelector toSuppress |
	interfaces _ self methodInterfacesForCategory: aCategorySymbol inVocabulary: aViewer currentVocabulary limitClass: aViewer limitClass.
	interfaces _ self methodInterfacesInPresentationOrderFrom: interfaces forCategory: aCategorySymbol.
	toSuppress _ aViewer currentVocabulary phraseSymbolsToSuppress.
	interfaces _ interfaces select: [:int | (toSuppress includes: int selector) not].
	Preferences universalTiles ifFalse:
		[interfaces _ interfaces select:
			[:int |
				itsSelector _ int selector.
				itsSelector numArgs < 2 or:
					"The lone two-arg loophole in classic tiles"
					[#(color:sees:) includes: itsSelector]]].
	^ interfaces collect:
		[:aMethodInterface |
			aMethodInterface wantsReadoutInViewer
				ifTrue:
					[aViewer phraseForVariableFrom: aMethodInterface]
				ifFalse:
					[aViewer phraseForCommandFrom: aMethodInterface]]! !

!Object methodsFor: 'viewer' stamp: 'sw 5/4/2001 04:51'!
tileToRefer
	"Answer a reference tile that comprises an alias to me"

	^ TileMorph new setToReferTo: self! !

!Object methodsFor: 'viewer' stamp: 'sw 10/17/2000 11:27'!
uniqueInstanceVariableNameLike: aString excluding: takenNames
	"Answer a nice instance-variable name to be added to the receiver which resembles aString, making sure it does not coincide with any element in takenNames"

	| okBase uniqueName usedNames |
	usedNames _ self class allInstVarNamesEverywhere.
	usedNames removeAllFoundIn: self class instVarNames.
	usedNames addAll: takenNames.
	okBase _ Utilities wellFormedInstanceVariableNameFrom: aString.

	uniqueName _ Utilities keyLike: okBase satisfying: 
		[:aKey | (usedNames includes: aKey) not].

	^ uniqueName! !

!Object methodsFor: 'viewer' stamp: 'sw 11/21/2001 15:16'!
uniqueNameForReference
	"Answer a nice name by which the receiver can be referred to by other objects.  At present this uses a global References dictionary to hold the database of references, but in due course this will need to acquire some locality"

	| aName nameSym stem knownClassVars |
	(aName _ self uniqueNameForReferenceOrNil) ifNotNil: [^ aName].
	(stem _ self knownName) ifNil:
		[stem _ self defaultNameStemForInstances asString].
	stem _ stem select: [:ch | ch isLetter or: [ch isDigit]].
	stem size == 0 ifTrue: [stem _ 'A'].
	stem first isLetter ifFalse:
		[stem _ 'A', stem].
	stem _ stem capitalized.
	knownClassVars _ ScriptingSystem allKnownClassVariableNames.
	aName _ Utilities keyLike:  stem satisfying:
		[:jinaLake |
			nameSym _ jinaLake asSymbol.
			 ((References includesKey:  nameSym) not and:
				[(Smalltalk includesKey: nameSym) not]) and:
						[(knownClassVars includes: nameSym) not]].

	References at: (aName _ aName asSymbol) put: self.
	^ aName! !

!Object methodsFor: 'viewer' stamp: 'sw 3/7/2002 01:01'!
uniqueNameForReferenceFrom: proposedName
	"Answer a satisfactory symbol, similar to the proposedName but obeying the rules, to represent the receiver"

	| aName nameSym stem knownClassVars |
	proposedName = self uniqueNameForReferenceOrNil 
		ifTrue: [^ proposedName].  "No change"

	stem _ proposedName select: [:ch | ch isLetter or: [ch isDigit]].
	stem size == 0 ifTrue: [stem _ 'A'].
	stem first isLetter ifFalse:
		[stem _ 'A', stem].
	stem _ stem capitalized.
	knownClassVars _ ScriptingSystem allKnownClassVariableNames.
	aName _ Utilities keyLike: stem satisfying:
		[:jinaLake |
			nameSym _ jinaLake asSymbol.
			 (References includesKey:  nameSym) not and:
				[(knownClassVars includes: nameSym) not]].
	^ aName asSymbol! !

!Object methodsFor: 'viewer' stamp: 'sw 11/21/2001 15:18'!
uniqueNameForReferenceOrNil
	"If the receiver has a unique name for reference, return it here, else return nil"

	| aName |
	(References includesIdentity: self) ifTrue: [^ References keyAtValue: self].

	(aName _ Smalltalk keyAtValue: self ifAbsent: [nil]) ifNotNil: [^ aName].
	^ nil! !

!Object methodsFor: 'viewer' stamp: 'ar 5/16/2001 01:40'!
updateThresholdForGraphicInViewerTab
	"When a Viewer is open on the receiver, its tab needs some graphic to show to the user. Computing this graphic can take quite some time so we want to make the update frequency depending on how long it takes to compute the thumbnail. The threshold returned by this method defines that the viewer will update at most every 'threshold * timeItTakesToDraw' milliseconds. Thus, if the time for computing the receiver's thumbnail is 200 msecs and the the threshold is 10, the viewer will update at most every two seconds."
	^20 "seems to be a pretty good general choice"! !

!Object methodsFor: 'viewer' stamp: 'sw 3/9/2001 13:48'!
usableMethodInterfacesIn: aListOfMethodInterfaces
	"Filter aList, returning a subset list of apt phrases"

	^ aListOfMethodInterfaces
! !

!Object methodsFor: 'world hacking' stamp: 'ar 3/17/2001 23:45'!
couldOpenInMorphic

        "is there an obvious morphic world in which to open a new morph?"

        ^World notNil or: [ActiveWorld notNil]! !

!Object methodsFor: 'private'!
errorImproperStore
	"Create an error notification that an improper store was attempted."

	self error: 'Improper store into indexable object'! !

!Object methodsFor: 'private'!
errorNonIntegerIndex
	"Create an error notification that an improper object was used as an index."

	self error: 'only integers should be used as indices'! !

!Object methodsFor: 'private' stamp: 'di 3/29/1999 12:39'!
errorNotIndexable
	"Create an error notification that the receiver is not indexable."

	self error: (self class name) , 's are not indexable'! !

!Object methodsFor: 'private'!
errorSubscriptBounds: index 
	"Create an error notification that an improper integer was used as an index."

	self error: 'subscript is out of bounds: ' , index printString! !

!Object methodsFor: 'private' stamp: 'ar 3/17/2001 23:52'!
primitiveError: aString 
	"This method is called when the error handling results in a recursion in 
	calling on error: or halt or halt:."

	| context |
	Sensor eventQueue: nil. "Or else we won't get keyboard and possibly run out of memory"
	(String
		streamContents: 
			[:s |
			s nextPutAll: '***System error handling failed***'.
			s cr; nextPutAll: aString.
			context _ thisContext sender sender.
			20 timesRepeat: [context == nil ifFalse: [s cr; print: (context _ context sender)]].
			s cr; nextPutAll: '-------------------------------'.
			s cr; nextPutAll: 'Type CR to enter an emergency evaluator.'.
			s cr; nextPutAll: 'Type any other character to restart.'])
		displayAt: 0 @ 0.
	[Sensor keyboardPressed] whileFalse.
	Sensor keyboard = Character cr ifTrue: [Transcripter emergencyEvaluator].
	Smalltalk isMorphic
		ifTrue: [World install "init hands and redisplay"]
		ifFalse: [ScheduledControllers searchForActiveController]! !

!Object methodsFor: 'private'!
species
	"Answer the preferred class for reconstructing the receiver.  For example, 
	collections create new collections whenever enumeration messages such as 
	collect: or select: are invoked.  The new kind of collection is determined by 
	the species of the original collection.  Species and class are not always the 
	same.  For example, the species of Interval is Array."

	^self class! !

!Object methodsFor: 'private'!
storeAt: offset inTempFrame: aContext
	"This message had to get sent to an expression already on the stack
	as a Block argument being accessed by the debugger.
	Just re-route it to the temp frame."
	^ aContext tempAt: offset put: self! !

!Object methodsFor: 'scripts-kernel' stamp: 'tk 9/28/2001 13:30'!
universalTilesForGetterOf: aMethodInterface
	"Return universal tiles for a getter on the given method interface."

	| ms argTile argArray itsSelector |
	itsSelector _ aMethodInterface selector.
	argArray _ #().

	"Three gratuituous special cases..."

	(itsSelector == #color:sees:) ifTrue:
		[argTile _ ScriptingSystem tileForArgType: #Color.
		argArray _ Array with: argTile colorSwatch color with: argTile colorSwatch color copy].

	itsSelector == #seesColor: ifTrue:
		[argTile _ ScriptingSystem tileForArgType: #Color.
		argArray _  Array with: argTile colorSwatch color].

	itsSelector == #touchesA: ifTrue:
		[argTile _ ScriptingSystem tileForArgType: #Player.
		argArray _ Array with: argTile actualObject].

	ms _ MessageSend receiver: self selector: itsSelector arguments: argArray.
	^ ms asTilesIn: self class globalNames: (self class officialClass ~~ CardPlayer)
			"For CardPlayers, use 'self'.  For others, name it, and use its name."! !

!Object methodsFor: 'scripts-kernel' stamp: 'tk 9/28/2001 13:30'!
universalTilesForInterface: aMethodInterface
	"Return universal tiles for the given method interface.  Record who self is."

	| ms argTile itsSelector aType argList |
	itsSelector _ aMethodInterface selector.
	argList _ OrderedCollection new.
	aMethodInterface argumentVariables doWithIndex:
		[:anArgumentVariable :anIndex | 
			argTile _ ScriptingSystem tileForArgType: (aType _ aMethodInterface typeForArgumentNumber: anIndex).
			argList add: (aType == #Player 
				ifTrue: [argTile actualObject]
				ifFalse: [argTile literal]).	"default value for each type"].

	ms _ MessageSend receiver: self selector: itsSelector arguments: argList asArray.
	^ ms asTilesIn: self class globalNames: (self class officialClass ~~ CardPlayer)
			"For CardPlayers, use 'self'.  For others, name it, and use its name."! !

!Object methodsFor: 'parts bin' stamp: 'sw 10/24/2001 16:34'!
descriptionForPartsBin
	"If the receiver is a member of a class that would like to be represented in a parts bin, answer the name by which it should be known, and a documentation string to be provided, for example, as balloon help.  When the 'nativitySelector' is sent to the 'globalReceiver', it is expected that some kind of Morph will result.  The parameters used in the implementation below are for documentation purposes only!!"

	^ DescriptionForPartsBin
		formalName: 'PutFormalNameHere'
		categoryList: #(PutACategoryHere MaybePutAnotherCategoryHere)
		documentation: 'Put the balloon help here'
		globalReceiverSymbol: #PutAGlobalHere
		nativitySelector: #PutASelectorHere! !

!Object methodsFor: 'Camp Smalltalk' stamp: 'SSS 7/3/2000 11:04'!
sunitAddDependent: anObject

        self addDependent: anObject! !

!Object methodsFor: 'Camp Smalltalk' stamp: 'SSS 7/3/2000 11:04'!
sunitChanged: anAspect

        self changed: anAspect! !

!Object methodsFor: 'Camp Smalltalk' stamp: 'SSS 7/3/2000 11:05'!
sunitRemoveDependent: anObject

        self removeDependent: anObject! !

!Object methodsFor: 'creation' stamp: 'sw 1/29/2002 21:43'!
asMorph
	"Open a morph, as best one can, on the receiver"

	^ self asString asMorph

	"
234 asMorph
(ScriptingSystem formAtKey: #TinyMenu) asMorph
'fred' asMorph
"

! !

!Object methodsFor: 'creation' stamp: 'sw 1/29/2002 21:45'!
openAsMorph
	"Open a morph, as best one can, on the receiver"

	^ self asMorph openInHand

"
234 openAsMorph
(ScriptingSystem formAtKey: #TinyMenu) openAsMorph
'fred' openAsMorph
"! !

!Object methodsFor: 'Squeak Life addOn' stamp: 'foo 9/19/2002 16:48'!
changed: changeType with: parameter 
	"Duplication of changed: by Roland Bertuli for Squeak Life"
	self dependents
		do: [:aDependent | aDependent update: changeType with: parameter]! !


!Area methodsFor: 'accessing' stamp: 'RB 8/12/2002 23:12'!
center
	"Answer the center of the area"
	^ (width / 2.0) integerPart @ (height / 2.0) integerPart! !

!Area methodsFor: 'accessing'!
height
	"Return height area"

	^height! !

!Area methodsFor: 'accessing'!
width
	"Return width area"

	^width! !

!Area methodsFor: 'beasts' stamp: 'RB 8/22/2002 21:25'!
addBeast: beast 
	"Add a beast into area"
	"Don't put the beast on existing beast"
	[self isIntoBeast: beast x @ beast y]
		whileTrue: [Calculation randomBool
				ifTrue: [beast x > (beast frontDistance * 3)
						ifTrue: [beast x: beast x - (beast frontDistance * 2)]]
				ifFalse: [beast x < (width - (beast frontDistance * 3))
						ifTrue: [beast x: beast x - (beast frontDistance * 2)]]].
	"Add beast into area"
	beastList add: beast! !

!Area methodsFor: 'beasts'!
beastList
	"Return the list of all beasts contained in area"

	^beastList! !

!Area methodsFor: 'beasts' stamp: 'br 8/15/2002 14:52'!
clearBeasts
	"Clear area of all these obstacles"
	beastList := OrderedCollection new! !

!Area methodsFor: 'beasts'!
containsBeast: aBeast 
	"Return true if the beast is in the area else false"
	^ (beastList
		select: [:i | i = aBeast]) isEmpty not
! !

!Area methodsFor: 'beasts'!
isIntoBeast: aPoint 
	"Answer if a point is contained into a beast"
	^ (beastList
		select: [:i | i containsPoint: aPoint]) isEmpty not! !

!Area methodsFor: 'beasts' stamp: 'RB 8/11/2002 22:15'!
removeBeast: beast 
	"Remove a beast to area"
	beastList remove: beast.
	"Refresh GUI"
	beast changed: #dead! !

!Area methodsFor: 'evolution' stamp: 'RB 8/12/2002 22:47'!
endEvolution
	"Terminate the evolution of our world"
	processStarted
		ifTrue: [process terminate]! !

!Area methodsFor: 'evolution' stamp: 'RB 8/12/2002 22:46'!
startEvolution
	"Begin the evolution of our world"
	processSuspended ifTrue: [
	process resume.
	processSuspended := false]! !

!Area methodsFor: 'evolution' stamp: 'RB 8/12/2002 22:45'!
stopEvolution
	"Stop the evolution of our world"
	processSuspended ifFalse: [
	process suspend.
	processSuspended := true]! !

!Area methodsFor: 'initializing' stamp: 'br 8/15/2002 14:37'!
clear
	"Reset the area, remove all beasts and obstacles"
	"self halt."
	self clearBeasts.
	self clearObstacles.
	self changed: #reset! !

!Area methodsFor: 'initializing' stamp: 'RB 8/12/2002 22:44'!
initialize: newHeight on: newWidth 
	"Initialize an instance of Area"
	| delay |
	height _ newHeight.
	width _ newWidth.
	viewDiminution _ 0.
	groundDiminution _ 0.
	airDiminution _ 0.
	"Create the process who ran the area progress"
	processStarted _ true.
	processSuspended := true.
	delay _ Delay forMilliseconds: 20.
	process _ [[true]
				whileTrue: [processStarted
						ifTrue: [self progress.
							delay wait]]] newProcess.
	beastList _ OrderedCollection new.
	obstacleList _ OrderedCollection new! !

!Area methodsFor: 'obstacles'!
addObstacle: obstacle
	"Add an obstacle into area"

	obstacleList add: obstacle! !

!Area methodsFor: 'obstacles' stamp: 'br 8/15/2002 14:52'!
clearObstacles
	"Clear area of all these obstacles"
	obstacleList _ OrderedCollection new! !

!Area methodsFor: 'obstacles'!
isIntoObstacle: aPoint
	"Answer if a point is contained into an obstacle of area"
	^ (obstacleList
		select: [:i | i containsPoint: aPoint]) isEmpty not! !

!Area methodsFor: 'obstacles'!
obstacleList
	"Return the list of all obstacles contained in area"

	^obstacleList! !

!Area methodsFor: 'obstacles' stamp: 'br 8/15/2002 14:53'!
progress
	"All beasts go on through the area"
	beastList
		do: [:each | each walks]! !

!Area methodsFor: 'obstacles' stamp: 'RB 8/11/2002 22:16'!
removeObstacle: obstacle 
	"Remove an obstacle to area"
	obstacleList remove: obstacle.
	"Refresh GUI"
	obstacle changed: #removed! !

!Area methodsFor: 'testing' stamp: 'foo 8/12/2002 14:33'!
isOutCoord: aPosition 
	"Answer if coordinates are out or in the area"
	^ aPosition x <= 0 | (aPosition x >= width) | (aPosition y <= 0) | (aPosition y >= height)! !

!Area methodsFor: 'testing' stamp: 'rb 8/11/2002 16:12'!
isRunning
	^processStarted! !


!AreaMorph methodsFor: 'accessing' stamp: 'rb 8/11/2002 15:59'!
area
	^area! !

!AreaMorph methodsFor: 'evolution' stamp: 'RB 8/12/2002 22:48'!
endEvolution
	"Terminate the evolution of our world"
	area endEvolution! !

!AreaMorph methodsFor: 'evolution'!
startEvolution
	"Begin the evolution of our world"
	area startEvolution! !

!AreaMorph methodsFor: 'evolution'!
stopEvolution
	"Stop the evolution of our world"
	area stopEvolution! !

!AreaMorph methodsFor: 'worlds' stamp: 'RB 8/26/2002 22:17'!
attack
	"Create a world where an elephant is hunting"
	self
		addBeast: 140 @ 230
		color: Color blue
		behavior: BehaviourPredator.
	self
		addBeast: 10 @ 10
		color: Color green
		behavior: BehaviourRound.
	self
		addBeast: 140 @ 130
		color: Color yellow
		behavior: BehaviourRound.
	self
		addBeast: 200 @ 200
		color: Color green
		behavior: BehaviourStraight.
	self
		addBeast: 100 @ 250
		color: Color blue
		behavior: BehaviourRandom.
	self
		addBeast: 50 @ 200
		color: Color red
		behavior: BehaviourRound.
	self
		addBeast: area center
		color: Color black
		behavior: BehaviourRound.
 self
		addBeast: 150 @ 150
		color: Color gray
		behavior: BehaviourStraight.
	! !

!AreaMorph methodsFor: 'worlds' stamp: 'RB 8/26/2002 22:19'!
pigFlock
	"Create a world where a flock pig is evoluting"
	| leader |
	leader := self
		addBeast: 150 @ 150
		color: Color gray
		behavior: BehaviourStraight.
	leader brain addBehavior: (BehaviourAvoid
				new: leader brain
				on: area
				with: 5).
	self
		addBeast: 140 @ 130
		color: Color gray
		behavior: BehaviourFlock.
	self
		addBeast: 200 @ 200
		color: Color gray
		behavior: BehaviourFlock.
	self
		addBeast: 100 @ 250
		color: Color gray
		behavior: BehaviourFlock.
	self
		addBeast: 50 @ 200
		color: Color gray
		behavior: BehaviourFlock! !

!AreaMorph methodsFor: 'worlds' stamp: 'RB 8/12/2002 23:23'!
reset
	"Reset the current world"
	self removeAllMorphs! !

!AreaMorph methodsFor: 'worlds' stamp: 'RB 8/26/2002 22:21'!
target
	"Create a world where a ladybird go to a target and avoid obstacle"
	| beast |
	beast _ self
				addBeast: 350 @ 350
				color: Color red
				behavior: BehaviourAvoid.
	beast brain
		addBehavior: (BehaviourTarget
				new: beast brain
				on: area
				with: 5).
beast brain target: 30 @ 30.
	self
		addObstacle: 50 @ 60
		width: 50
		height: 50.
	self
		addObstacle: 50 @ 150
		width: 50
		height: 50.
	self
		addObstacle: 170 @ 50
		width: 50
		height: 50.
	self
		addObstacle: 220 @ 200
		width: 50
		height: 50.
	self
		addObstacle: 130 @ 200
		width: 50
		height: 50! !

!AreaMorph methodsFor: 'updating' stamp: 'foo 8/13/2002 09:34'!
update: changeType 
	"Update the AreaMorph by Area message"
	changeType == #reset
		ifTrue: [self removeAllMorphs]! !

!AreaMorph methodsFor: 'adding' stamp: 'RB 8/26/2002 22:13'!
addBeast: aPosition color: aColor behavior: aBehavior 
	"Add a beast to a specified position of the area"
	| newBeast direction |
	direction _ 200.
	"Creation of the beast"
	newBeast _ Beast
				new: aPosition
				direction: direction
				speed: 3
				color: aColor.
	"Behaviors"
	newBeast brain
		addBehavior: (aBehavior
				new: newBeast brain
				on: area
				with: 5).
	"Add beast into the area"
	area addBeast: newBeast.
	"Create the morph who represents the beast"
	self addBeastMorph: newBeast.
	"Return the beast"
	^ newBeast! !

!AreaMorph methodsFor: 'adding' stamp: 'RB 8/25/2002 22:46'!
addObstacle: position width: w height: h 
	| newObstacle |
	newObstacle _ Obstacle
				new: position
				width: w
				height: h.
	"Add the obstacle into the area"
	area addObstacle: newObstacle.
"Create the morph who represents the beast"
	self addObstacleMorph: newObstacle! !

!AreaMorph methodsFor: 'initializing' stamp: 'RB 8/26/2002 22:39'!
initialize
	super initialize.
	area _ Area new: 385 on: 360.
	self width: area width;
		 height: area height.
	area addDependent: self.! !

!AreaMorph methodsFor: 'create morphs' stamp: 'RB 8/25/2002 22:42'!
addBeastMorph: aBeast 
	"Create the morph who represents the beast"
	| newMorph |
	newMorph _ BeastMorph new: aBeast.
	newMorph
		bounds: (newMorph bounds translateBy: self topLeft).
	"Add BeastMorph into the AreaMorph"
	self addMorphFront: newMorph! !

!AreaMorph methodsFor: 'create morphs' stamp: 'RB 8/25/2002 22:46'!
addObstacleMorph: anObstacle 
	"Create the morph who represents the obstacle"
	| newMorph |

	newMorph _ ObstacleMorph new: anObstacle.
	newMorph
		bounds: (newMorph bounds translateBy: self topLeft).
	self addMorphFront: newMorph! !


!Beast methodsFor: 'accessing'!
brain
	"Return beast's brain"

	^brain! !

!Beast methodsFor: 'accessing' stamp: 'RB 8/22/2002 21:20'!
color
	"Answer the color of the beast"
	^ color! !

!Beast methodsFor: 'accessing'!
courseNb
	"Answer the course number of the beast"

	^courseNb! !

!Beast methodsFor: 'accessing'!
currentSpeed
	"Answer the current speed of the beast"

	^currentSpeed! !

!Beast methodsFor: 'accessing'!
direction
	"Answer the direction of the beast"

	^direction! !

!Beast methodsFor: 'accessing'!
frontDistance
	"Return the distance between the beast front and its center"

	^front! !

!Beast methodsFor: 'accessing'!
maxSpeed
	"Answer the max speed of the beast"

	^maxSpeed! !

!Beast methodsFor: 'accessing' stamp: 'RB 8/21/2002 21:22'!
position
	"Answer the position point of the beast"
	^ position! !

!Beast methodsFor: 'accessing'!
viewDistance
	"Answer the view distance of the beast"

	^viewDistance! !

!Beast methodsFor: 'accessing' stamp: 'RB 8/21/2002 21:41'!
x
	"Answer the X coordinate of the beast"
	^ position x! !

!Beast methodsFor: 'accessing' stamp: 'RB 8/21/2002 21:41'!
y
	"Answer the Y coordinate of the beast"
	^ position y! !

!Beast methodsFor: 'evolution' stamp: 'RB 8/21/2002 22:53'!
goesOn: speed 
	"The beast does a past towards its current direction with a specified speed"
	| cos sin |
	cos _ (Calculation degToRad: direction) cos * speed.
			sin _ (Calculation degToRad: direction) sin * speed.
			coordX _ coordX + cos - cos integerPart.
			coordY _ coordY + sin - sin integerPart.
			self position: position x + cos integerPart + coordX integerPart @ (position y + sin integerPart + coordY integerPart).
			coordX _ coordX - coordX integerPart.
			coordY _ coordY - coordY integerPart! !

!Beast methodsFor: 'evolution' stamp: 'RB 8/12/2002 23:43'!
grows
	"The beast grows after eating"
	front _ front + 1.
	self changed: #grow! !

!Beast methodsFor: 'evolution'!
turnTo: turn 
	"Turn beast of a degree angle"
	"Refresh position on GUI"
	"self changed: #turnTo with: turn."
	direction _ Calculation simplifyAngle: direction + turn! !

!Beast methodsFor: 'evolution' stamp: 'RB 8/21/2002 22:54'!
walks
	"The beast thinks and goes on"
	| course turn |
	course _ brain findDirection.
	course = nil
		ifFalse: ["Change course if a direction was found"
			turn _ course - (courseNb / 2.0) integerPart - 1.
			self turnTo: turn * 5.
			"The beast goes on"
			self isRunning
				ifTrue: [self goesOn: maxSpeed]
ifFalse: [self goesOn: currentSpeed]]! !

!Beast methodsFor: 'initializing' stamp: 'RB 8/22/2002 22:15'!
initialize: aPoint direction: curDir speed: curSpeed color: aColor 
	"Initialize an instance of Beast"
	brain _ Brain new: self.
	position _ aPoint.
	direction _ curDir.
	maxSpeed _ 7.
	currentSpeed _ curSpeed.
	color _ aColor.
	courseNb _ 21.
	viewDistance _ 150.
	front _ 3.
	coordX _ 0.
	coordY _ 0.
	running _ false! !

!Beast methodsFor: 'setting'!
brain: newBrain
	"Set the brain of the beast"
	brain _ newBrain! !

!Beast methodsFor: 'setting' stamp: 'RB 8/22/2002 21:21'!
color: aColor 
	"Set the color of the beast"
	color _ aColor! !

!Beast methodsFor: 'setting'!
courseNb: number 
	"Set the course number of the beast, it also represents vision angle  
	of the beast by this equation:  
	degree angle vision = (courseNb - 1) * 5 
	This number must be odd"
	number > 0
		ifTrue: [number even
				ifTrue: [courseNb _ number + 1]
				ifFalse: [courseNb _ number]]
		ifFalse: [courseNb _ 0]! !

!Beast methodsFor: 'setting' stamp: 'RB 8/22/2002 21:38'!
currentSpeed: aSpeed 
	"Set the current speed of the beast"
	maxSpeed < aSpeed ifTrue: [currentSpeed _ maxSpeed]
	ifFalse: [currentSpeed _ aSpeed]! !

!Beast methodsFor: 'setting'!
direction: newDirection 
	"Set the direction of the beast"
	"self changed: #setDirection with: newDirection."
	direction _ Calculation simplifyAngle: newDirection! !

!Beast methodsFor: 'setting'!
frontDistance: frontDistance 
	"Set the front distance of the beast"
	front _ frontDistance! !

!Beast methodsFor: 'setting'!
maxSpeed: speed 
	"Set the max speed of the beast"
	maxSpeed _ speed! !

!Beast methodsFor: 'setting' stamp: 'RB 8/21/2002 22:45'!
position: aPoint 
	"Set the position point of the beast"
	| translation |
	translation _ aPoint x - position x @ (aPoint y - position y).
	position _ aPoint.
	"Refresh position on GUI"
	self changed: #translated with: translation! !

!Beast methodsFor: 'setting'!
running: run 
	"Set the running flag of the beast"
	running _ run! !

!Beast methodsFor: 'setting'!
viewDistance: distance 
	"Set the view distance of the beast"
	viewDistance _ distance! !

!Beast methodsFor: 'setting' stamp: 'RB 8/21/2002 22:41'!
x: xCoord 
	"Set the X coordinate of the beast"
	position _ xCoord @ position y! !

!Beast methodsFor: 'setting' stamp: 'RB 8/21/2002 21:38'!
y: yCoord 
	"Set the Y coordinate of the beast"
	position _ position x @ yCoord ! !

!Beast methodsFor: 'testing' stamp: 'RB 8/21/2002 21:30'!
containsPoint: aPoint 
	"Answer if the beast contain a point"
	^ ((aPoint x - position x) squared + (aPoint y - position y) squared) sqrt < front! !

!Beast methodsFor: 'testing' stamp: 'foo 9/18/2002 11:16'!
hasLeader
	"Answer if the beast has a leader"
	4! !

!Beast methodsFor: 'testing'!
isRunning
	"Answer if the beast is running"

	^running! !


!BeastMorph methodsFor: 'initializing' stamp: 'RB 8/22/2002 22:11'!
initialize: aBeast 
	"Initialize a BeastMorph instance"
	| front |
	super initialize.
	"The color depends of the beast species"
	self color: aBeast color.
	front := aBeast frontDistance.
	self extent: front * 2 @ (front * 2).
	self
		bounds: (self bounds translateBy: aBeast x - front @ aBeast y - front).
	"Make dependent between the beast and its morph"
	aBeast addDependent: self! !

!BeastMorph methodsFor: 'updating' stamp: 'br 8/15/2002 14:15'!
update: changeType 
	"Update the BeastMorph by Beast message"
	changeType == #dead
		ifTrue: [
			self owner removeAllMorphsIn: {self}]
		ifFalse: [changeType == #grow
				ifTrue: [self extent: self extent x + 1 @ (self extent y + 1)]]! !

!BeastMorph methodsFor: 'updating' stamp: 'RB 8/21/2002 22:48'!
update: changeType with: parameter 
	"Update the BeastMorph by Beast message"
	changeType == #translated
		ifTrue: [self
				bounds: (bounds translateBy: parameter)]! !


!Behaviour methodsFor: 'accessing'!
area
	"Return evolving area"

	^area! !

!Behaviour methodsFor: 'accessing'!
weight
	"Return weight behavior for brain"

	^weight! !

!Behaviour methodsFor: 'courses' stamp: 'foo 8/1/2002 14:01'!
equalCourses
	"Gives the same note at all courses, that note is equal to 100 / courseNb"
	1
		to: coursePossibilities size
		do: [:i | coursePossibilities
				at: i
				put: 100.0 / coursePossibilities size]! !

!Behaviour methodsFor: 'courses' stamp: 'foo 8/12/2002 14:48'!
levelWeight
	"Changes coursePossibilities to level weights to obtain a total of 100"
	| totalWeight coef |
	totalWeight _ 0.
	coursePossibilities
		do: [:course | totalWeight _ totalWeight + course].
	coef _ 100.0 / totalWeight.
	1
		to: coursePossibilities size
		do: [:i | coursePossibilities
				at: i
				put: (coef * coursePossibilities at: i)]! !

!Behaviour methodsFor: 'courses' stamp: 'RB 8/24/2002 22:48'!
nearestCourse: direction 
	"Determine which possible course is nearest a direction"
	| courseNb bestCourse minDirection maxDirection min max |
	courseNb _ coursePossibilities size.
	"Extrem directions of the animal vision"
	minDirection _ beast direction - ((courseNb / 2.0) integerPart * 5).
	maxDirection _ beast direction + ((courseNb / 2.0) integerPart * 5).
	"Best course"
	bestCourse _ 0.
	(Calculation
			angleContained: direction
			between: minDirection
			to: maxDirection)
		ifTrue: ["The direction is in sight"
			1
				to: courseNb
				do: [:i | (direction - beast direction - (i - 1 - (courseNb / 2.0) integerPart * 5)) abs < 5
						ifTrue: ["Best course found"
							direction - beast direction - (i - 1 - courseNb * 5) abs < (direction - beast direction - (i - courseNb * 5) abs)
								ifTrue: [bestCourse _ i - 1]
								ifFalse: [bestCourse _ i]]]]
		ifFalse: ["The direction isn't in sight, we take a best extrem  
			direction"
			min _ Calculation formedAngleBy: minDirection and: direction.
			max _ Calculation formedAngleBy: maxDirection and: direction.
			min < max
				ifTrue: [bestCourse _ 1]
				ifFalse: [bestCourse _ courseNb]].
	^ bestCourse! !

!Behaviour methodsFor: 'initializing'!
initialize: newBrain on: newArea with: newWeight 
	"Initialize an instance of behavior"
	brain _ newBrain.
	area _ newArea.
	beast _ brain beast.
	weight _ newWeight.
	coursePossibilities _ Array new: beast courseNb withAll:0! !

!Behaviour methodsFor: 'setting'!
weight: newWeight 
	"Set weight behavior for brain"
	weight _ newWeight! !


!BehaviourAvoid methodsFor: 'recommendation' stamp: 'RB 8/25/2002 22:24'!
avoidCourses: badCourses 
	"Create recommendations to avoid bad courses and fill out 
	coursePossibilities. badCourses is an OrderedCollection who contains 
	courses to avoid."
	"noObstacle is a flag who locates a run up against obstacle"
	| noObstacle tmpArray |
	noObstacle _ true.
	badCourses
		do: [:course | 
			tmpArray _ Array new: coursePossibilities size withAll: 0.
			1
				to: coursePossibilities size
				do: [:i | 
					tmpArray at: i put: (i - 1 - course) abs * 5.
					noObstacle
						ifTrue: [coursePossibilities
								at: i
								put: (tmpArray at: i)]
						ifFalse: [(coursePossibilities at: i)
									> (tmpArray at: i)
								ifTrue: [coursePossibilities
										at: i
										put: (tmpArray at: i)]]].
			noObstacle _ false]! !

!BehaviourAvoid methodsFor: 'recommendation' stamp: 'RB 8/26/2002 22:50'!
findRecommendation
	"Return a graph of course recommendations evaluated by an avoid behavior"
	| badCourses |
	badCourses _ brain seenObstacles.
	self avoidCourses: badCourses.
	badCourses isEmpty
		ifTrue: ["No obstacle so random step"
			self equalCourses]
		ifFalse: ["If obstacle, to level weights to obtain a total of 100"
			self levelWeight].
	^ coursePossibilities! !


!BehaviourFlock methodsFor: 'recommendation' stamp: 'RB 8/25/2002 21:01'!
detectFellow
	"Return the nearest beast of the same species to the purview"
	| fellow seenBeasts minDistance |
	seenBeasts _ brain seenBeasts.
	minDistance _ beast viewDistance + 1.
	"The nearest beast is initialized to nil"
	fellow _ nil.
	seenBeasts
		do: [:each | (Calculation distance: beast position to: each position)
					< minDistance & (beast color = each color)
				ifTrue: ["The beast has found a fellow"
					fellow _ each.
					minDistance _ Calculation distance: beast position to: each position]].
	^ fellow! !

!BehaviourFlock methodsFor: 'recommendation' stamp: 'RB 8/26/2002 22:51'!
findRecommendation
	"Return a graph of course recommendations evaluated by a behavior 
	who evoluates in flock"
	| leaderDirection bestCourse |
	leader = nil
		ifTrue: ["Beast hasn't leader, it's looking for a leader of its species"
			leader _ self detectFellow.
			leader = nil
				ifTrue: ["If no leader, the best does a random step to looking for  
					a leader"
					self equalCourses.
					^ coursePossibilities]].
	(area containsBeast: leader)
		ifFalse: ["The leader has been erased to area, random step"
			leader _ nil.
			self equalCourses.
			^ coursePossibilities].
	(Calculation distance: beast position to: leader position)
			< (beast frontDistance + leader frontDistance)
		ifTrue: ["Collision between the beast and its leader, so no step"
			1
				to: coursePossibilities size
				do: [:i | coursePossibilities at: i put: 0].
			^ coursePossibilities].
	"If all correct, the beast follows its leader"
	leaderDirection _ Calculation vectorDirection: beast position to: leader position.
	bestCourse _ self nearestCourse: leaderDirection.
	"The beast takes speed leader"
	(Calculation distance: beast position to: leader position)
			< beast viewDistance
		ifTrue: [leader isRunning
				ifTrue: [beast currentSpeed: leader maxSpeed]
				ifFalse: [beast currentSpeed: leader currentSpeed]]
		ifFalse: ["The beast runs to leader"
			beast currentSpeed: beast maxSpeed].
	"Arbitrary weights for courses"
	1
		to: coursePossibilities size
		do: [:i | coursePossibilities at: i put: 500 - ((i - 1 - bestCourse) abs * 5)].
	self levelWeight.
	^ coursePossibilities! !


!BehaviourPredator methodsFor: 'recommendation' stamp: 'RB 8/25/2002 21:04'!
detectAlien
	"Return the nearest beast of another species to the purview"
	| fellow seenBeasts minDistance |
	seenBeasts _ brain seenBeasts.
	minDistance _ beast viewDistance + 1.
	"The nearest beast is initialized to nil"
	fellow _ nil.
	seenBeasts
		do: [:each | (Calculation distance: beast position to: each position)
					< minDistance & (beast color = each color) not
				ifTrue: ["The beast has found a beast of another species"
					fellow _ each.
					minDistance _ Calculation distance: beast position to: each position.
"The beast runs"
	beast running: true.
]].
	^ fellow! !

!BehaviourPredator methodsFor: 'recommendation' stamp: 'RB 8/25/2002 22:06'!
eating
	"The predator is eating, it answers no recommandations, 
	so no step"
	"Meal in progress"
	time _ time + 1.
	1
		to: coursePossibilities size
		do: [:i | coursePossibilities at: i put: 0].
	^ coursePossibilities! !

!BehaviourPredator methodsFor: 'recommendation' stamp: 'RB 8/26/2002 22:51'!
findRecommendation
	"Return a graph of course recommendations evaluated by a predator behavior.  
	The beast hunts other species."
	| preyDirection bestCourse |
	(time = 0) not
		ifTrue: ["Beast is eating"
			time < 100
				ifTrue: ["Meal is in progress, no step"
					^ self eating]
				ifFalse: ["Meal is finished"
					beast grows.
					time _ 0]].
	prey = nil
		ifTrue: ["Beast isn't hunting, it's looking for a prey"
			prey _ self detectAlien].
	prey = nil
		ifFalse: ["The beast has a prey, it's going on its direction"
			(area containsBeast: prey)
				ifFalse: ["The victim isn't into area"
					prey _ nil.
					self equalCourses.
					^ coursePossibilities].
			(beast containsPoint: prey position)
				ifTrue: ["Beast catched its prey"
					^ self killPrey]
				ifFalse: ["Beast is going on its prey"
					preyDirection _ Calculation vectorDirection: beast position to: prey position.
					bestCourse _ self nearestCourse: preyDirection.
					"Arbitrary weights for courses"
					1
						to: coursePossibilities size
						do: [:i | coursePossibilities at: i put: 500 - ((i - 1 - bestCourse) abs * 5)].
					self levelWeight.
					^ coursePossibilities]].
	self equalCourses.
	^ coursePossibilities! !

!BehaviourPredator methodsFor: 'recommendation' stamp: 'RB 8/25/2002 22:09'!
killPrey
"The predator catchs its prey, so no step"
1
						to: coursePossibilities size
						do: [:i | coursePossibilities at: i put: 0].
					"Prey rests in peace"
					area removeBeast: prey.
					prey _ nil.
					"Murder begun"
					time _ 1.
					"Beast stops running"
					beast running: false.
					^ coursePossibilities! !

!BehaviourPredator methodsFor: 'setting'!
time: anInteger
	"Time in action"
	time := anInteger! !


!BehaviourPsycho methodsFor: 'recommendation' stamp: 'RB 8/25/2002 21:06'!
detectBeast
	"Return the nearest beast to the purview"
	| anothertBeast seenBeasts minDistance |
	seenBeasts _ brain seenBeasts.
	minDistance _ beast viewDistance + 1.
"The nearest beast is initialized to nil"
anothertBeast := nil.
	seenBeasts
		do: [:each | (Calculation distance: beast position to: each position)
					< minDistance
				ifTrue: [anothertBeast _ each.
					minDistance _ Calculation distance: beast position to: each position.
					"The psycho runs"
					beast running: true]].
	^ anothertBeast! !

!BehaviourPsycho methodsFor: 'recommendation' stamp: 'RB 8/25/2002 22:06'!
eating
	"The psycho is eating, it answers no recommandations,  
	so no step"
"Meal in progress"
	time _ time + 1.
	1
		to: coursePossibilities size
		do: [:i | coursePossibilities at: i put: 0].
	^ coursePossibilities! !

!BehaviourPsycho methodsFor: 'recommendation' stamp: 'RB 8/26/2002 22:51'!
findRecommendation
	"Return a graph of course recommendations evaluated by a psychopate behavior.  
	The beast hunts all other beasts."
	| victimDirection bestCourse |
	(time = 0) not
		ifTrue: ["Beast is killing"
			time < 100
				ifTrue: ["Murder is in progress, no step"
					^ self eating]
				ifFalse: ["Murder is finished"
					beast grows.
					time _ 0]].
	victim = nil
		ifTrue: ["Beast isn't hunting, it's looking for a victim"
			victim _ self detectBeast].
	victim = nil
		ifFalse: ["The beast has a victim, it's going on its direction"
			(area containsBeast: victim)
				ifFalse: ["The victim isn't into area"
					victim _ nil.
					self equalCourses.
					^ coursePossibilities].
			(beast containsPoint: victim position)
				ifTrue: ["Beast catched its victim"
					^ self killVictim]
				ifFalse: ["Beast is going on its victim"
					victimDirection _ Calculation vectorDirection: beast position to: victim position.
					bestCourse _ self nearestCourse: victimDirection.
					"Arbitrary weights for courses"
					1
						to: coursePossibilities size
						do: [:i | coursePossibilities at: i put: 500 - ((i - 1 - bestCourse) abs * 5)].
					self levelWeight.
					^ coursePossibilities]].
	self equalCourses.
	^ coursePossibilities! !

!BehaviourPsycho methodsFor: 'recommendation' stamp: 'RB 8/25/2002 22:11'!
killVictim
	"The psycho catchs its victim, so no step"
	1
		to: coursePossibilities size
		do: [:i | coursePossibilities at: i put: 0].
	"Victim rests in peace"
	area removeBeast: victim.
	victim _ nil.
	"Murder begun"
	time _ 1.
	"Beast stops running"
	beast running: false.
	^ coursePossibilities! !

!BehaviourPsycho methodsFor: 'setting'!
time: anInteger 
	"Time in action"
	time _ anInteger! !


!BehaviourRandom methodsFor: 'recommendation' stamp: 'RB 8/26/2002 22:52'!
findRecommendation
	"Return a graph of course recommendations evaluated by a random behavior"
	self equalCourses.
	^ coursePossibilities! !


!BehaviourRound methodsFor: 'recommendation' stamp: 'RB 8/26/2002 22:52'!
findRecommendation
	"Return a graph of course recommendations evaluated by a straight behavior"
	| courseNb |
	courseNb _ coursePossibilities size.
	1
		to: courseNb
		do: [:i | coursePossibilities at: i put: 100 - ((i - 2 - (courseNb / 2.0) integerPart) abs * 5)].
	self levelWeight.
	^ coursePossibilities! !


!BehaviourStraight methodsFor: 'recommendation' stamp: 'RB 8/26/2002 22:52'!
findRecommendation
	"Return a graph of course recommendations evaluated by a straight behavior"
	| courseNb |
	courseNb _ coursePossibilities size.
	1
		to: courseNb
		do: [:i | coursePossibilities at: i put: 100 - ((i - 1 - (courseNb / 2.0) integerPart) abs * 5)].
	self levelWeight.
	^ coursePossibilities! !


!BehaviourTarget methodsFor: 'recommendation' stamp: 'RB 8/26/2002 22:52'!
findRecommendation
	"Return a graph of course recommendations evaluated by a behavior who goes to a position"
	| targetDirection bestCourse |
	brain hasTarget
		ifTrue: ["Target has been allowed"
			(beast containsPoint: brain target)
				ifTrue: ["The beast was on the target so no step"
					^ self targetReached].
			"The beast looks for its target"
			targetDirection _ Calculation vectorDirection: beast position to: brain target.
			bestCourse _ self nearestCourse: targetDirection.
			"Arbitrary weights for courses"
			1
				to: coursePossibilities size
				do: [:i | coursePossibilities at: i put: 500 - ((i - 1 - bestCourse) abs * 5)].
			self levelWeight]
		ifFalse: ["No target allowed to beast, no step"
			1
				to: coursePossibilities size
				do: [:i | coursePossibilities at: i put: 0]].
	^ coursePossibilities! !

!BehaviourTarget methodsFor: 'recommendation' stamp: 'RB 8/25/2002 22:24'!
targetReached
	"The beast was on the target, no course recommendation,  
	so no step"
	1
		to: coursePossibilities size
		do: [:i | coursePossibilities at: i put: 0].
	brain removeTarget.
	^ coursePossibilities! !


!Brain methodsFor: 'accessing'!
beast
	"Return the beast who contains brain"

	^beast! !

!Brain methodsFor: 'accessing'!
behaviors
	"Return beast behaviors"

	^behaviors! !

!Brain methodsFor: 'accessing' stamp: 'RB 8/21/2002 21:51'!
target
	"Answer the position of the target"
	self hasTarget
		ifTrue: [^ target].
	^ 0 @ 0! !

!Brain methodsFor: 'behaviors'!
addBehavior: behavior 
	"Add behavior to brain"
	"At the first behavior, we register area"
	behaviors size = 0
		ifTrue: [area _ behavior area].
	behaviors add: behavior! !

!Brain methodsFor: 'behaviors'!
removeBehavior: behavior
	"remove behavior to brain"

	behaviors remove: behavior! !

!Brain methodsFor: 'evolution' stamp: 'RB 8/26/2002 23:04'!
bestCourses: coursePossibilities 
	"Answer an OrderedCollection who represents the best courses, 
	in function of behavior recommendations."
	| bestCourses maxCourse |
	bestCourses _ OrderedCollection new.
	maxCourse _ 1.
	1
		to: coursePossibilities size
		do: [:i | (coursePossibilities at: maxCourse)
					< (coursePossibilities at: i)
				ifTrue: [maxCourse _ i.
					bestCourses removeAll: bestCourses.
					bestCourses add: i]
				ifFalse: [(coursePossibilities at: maxCourse)
							= (coursePossibilities at: i)
						ifTrue: [bestCourses add: i]]].
	^ bestCourses! !

!Brain methodsFor: 'evolution' stamp: 'RB 8/26/2002 23:18'!
findDirection
	"Brain tries to find the best direction in function of its behaviors"
	"If no behaviors, the beast stays here"
	| coursePossibilities curCourses surveyor bestCourses maxCourse nextPosition |
	behaviors size = 0
		ifTrue: [^ nil].
	coursePossibilities _ Array new: beast courseNb withAll: 0.
	behaviors
		do: [:eachBehavior | 
			curCourses _ eachBehavior findRecommendation.
			surveyor _ 0.
			1
				to: curCourses size
				do: [:i | 
					surveyor _ surveyor
								+ (curCourses at: i).
					coursePossibilities at: i put: (coursePossibilities at: i)
							+ ((curCourses at: i)
									* eachBehavior weight)].
			"If no recommandation the beast don't walk"
			surveyor = 0
				ifTrue: [^ nil]].
	bestCourses _ self bestCourses: coursePossibilities.
	bestCourses size = 1
		ifTrue: ["One best course"
			maxCourse _ bestCourses at: 1]
		ifFalse: [bestCourses isEmpty
				ifTrue: ["If no course, the beast turns of an extrem angle"
					Calculation randomBool
						ifTrue: [maxCourse _ 1]
						ifFalse: [maxCourse _ coursePossibilities size]]
				ifFalse: ["We take a random course if more than one good course"
					maxCourse _ bestCourses atRandom]].
	"Verification to look for if there are not obstacle before"
	nextPosition _ self nextPosition: maxCourse.
	"Rebound on area extremities"
	(self outingArea: nextPosition)
		ifTrue: [^ nil].
	"Rebound on obstacle"
	(self obstacleRebound: nextPosition)
		ifTrue: [^ nil].
	^ maxCourse! !

!Brain methodsFor: 'evolution' stamp: 'RB 8/26/2002 23:17'!
nextPosition: aCourse 
	"Answer the next position before a past in the direction of the course"
	| cos sin nextX nextY  turn newDirection |
	turn _ aCourse - (beast courseNb / 2.0) integerPart - 1.
	newDirection _ turn * 5 + beast direction.

	cos _ (Calculation degToRad: newDirection) cos * beast frontDistance.
	sin _ (Calculation degToRad: newDirection) sin * beast frontDistance.
	"Determination of next step"
	nextX _ beast x + cos integerPart.
	nextY _ beast y + sin integerPart.
	^ nextX @ nextY! !

!Brain methodsFor: 'initializing'!
initialize: newBeast 
	"Initialize an instance of Brain contained into a Beast"
	beast _ newBeast.
	behaviors := OrderedCollection new! !

!Brain methodsFor: 'locating' stamp: 'RB 8/21/2002 21:08'!
beastHit
	"Return a beast hiten by our brain, if no hit then nil"
	^ area beastList
		detect: [:curBeast | curBeast !!= beast & Calculation
				distance: beast x @ beast y
				to: curBeast x @ curBeast y <= beast frontDistance + curBeast frontDistance]! !

!Brain methodsFor: 'locating'!
obstacleHit
	"Return a obstacle hiten by our brain, if no hit then nil"
	^ area obstacleList
		detect: [:curObstacle | curObstacle containsPoint: beast x @ beast y]
		ifNone: [^ nil]! !

!Brain methodsFor: 'locating' stamp: 'RB 8/21/2002 22:55'!
obstacleRebound: aPoint 
	"Treat rebound on obstacle"
	| obstacleHit newDirection |
	obstacleHit _ self obstacleHit.
	obstacleHit = nil
		ifFalse: ["Rebound on obstacle"
			newDirection _ obstacleHit
						reboundDirectionPixel: beast direction
						onPoint: aPoint x
						and: aPoint y.
			beast direction: newDirection;
				 goesOn: beast maxSpeed.
			^ true].
	"No crash on obstacle"
	^ false! !

!Brain methodsFor: 'locating' stamp: 'RB 8/21/2002 22:58'!
outingArea: aPoint 
	"Treat outing area"
	"Rebound on angle of the area"
	| newDirection |
	aPoint x <= 0 & (aPoint y <= 0)
		ifTrue: ["Go back"
			beast position: 1 @ 1.
			beast direction: beast direction + 180 \\ 360.
			beast goesOn: beast currentSpeed.
			^ true].
	aPoint x <= 0 & (aPoint y >= area width)
		ifTrue: ["Go back"
			beast position: 1 @ (area width - 1).
			beast direction: beast direction + 180 \\ 360;
				 goesOn: beast currentSpeed.
			^ true].
	aPoint x >= area height & (aPoint y <= 0)
		ifTrue: ["Go back"
			beast position: area height - 1 @ 1.
			beast direction: beast direction + 180 \\ 360;
				 goesOn: beast currentSpeed.
			^ true].
	aPoint x >= area height & (aPoint y >= area width)
		ifTrue: ["Go back"
			beast position: area height - 1 @ (area width - 1).
			beast direction: beast direction + 180 \\ 360;
				 goesOn: beast currentSpeed.
			^ true].
	aPoint x <= 0
		ifTrue: ["Left side rebound"
			newDirection _ Calculation reboundDirection: beast direction on: 0.
			beast x: 1.
			"Goes on"
			beast direction: newDirection;
				 goesOn: beast currentSpeed.
			"Test to see that we have not rebound into an obstacle"
			self obstacleHit = nil
				ifFalse: [beast direction: newDirection + 180 \\ 360;
						 goesOn: beast currentSpeed;
						 direction: beast direction + 180 \\ 360;
						 goesOn: beast currentSpeed].
			^ true].
	aPoint x >= area height
		ifTrue: ["Right side rebound"
			newDirection _ Calculation reboundDirection: beast direction on: 180.
			beast x: area height - 1.
			"Goes on"
			beast direction: newDirection;
				 goesOn: beast currentSpeed.
			"Test to see that we have not rebound into  
			an obstacle"
			self obstacleHit = nil
				ifFalse: [beast direction: newDirection + 180 \\ 360;
						 goesOn: beast currentSpeed;
						 direction: beast direction + 180 \\ 360;
						 goesOn: beast currentSpeed].
			^ true].
	aPoint y <= 0
		ifTrue: ["Top side rebound"
			newDirection _ Calculation reboundDirection: beast direction on: 90.
			beast y: 1.
			"Goes on"
			beast direction: newDirection;
				 goesOn: beast currentSpeed.
			"Test to see that we have not rebound  
			into an obstacle"
			self obstacleHit = nil
				ifFalse: [beast direction: newDirection + 180 \\ 360;
						 goesOn: beast currentSpeed;
						 direction: beast direction + 180 \\ 360;
						 goesOn: beast currentSpeed].
			^ true].
	aPoint y >= area width
		ifTrue: ["Bottom side rebound"
			newDirection _ Calculation reboundDirection: beast direction on: 270.
			beast y: area width - 1.
			"Goes on"
			beast direction: newDirection;
				 goesOn: beast currentSpeed.
			"Test to see that we have not  
			rebound into an obstacle"
			self obstacleHit = nil
				ifFalse: [beast direction: newDirection + 180 \\ 360;
						 goesOn: beast currentSpeed;
						 direction: beast direction + 180 \\ 360;
						 goesOn: beast currentSpeed].
			^ true].
	^ false! !

!Brain methodsFor: 'locating' stamp: 'RB 8/21/2002 21:18'!
seenBeasts
	"Return all beasts seen by the brain"
	| nbCourses directionMin directionMax x y |
	nbCourses _ beast courseNb.
	x _ beast x.
	y _ beast y.
	"Vision interval of brain"
	directionMin _ beast direction - (nbCourses / 2.0 * 5) integerPart.
	directionMax _ beast direction + (nbCourses / 2.0 * 5) integerPart.
	^ area beastList
		select: [:curBeast | (curBeast = beast) not
				& (Calculation
						angleContained: (Calculation
								vectorDirection: x @ y
								to: curBeast x @ curBeast y)
						between: directionMin
						to: directionMax) & ((Calculation distance: x @ y to: curBeast x @ curBeast y)
					<= beast viewDistance)]! !

!Brain methodsFor: 'locating' stamp: 'RB 8/12/2002 23:36'!
seenObstacles
	"Return all obstacles seen by the brain"
	| seenObstacle courseNb curCourse x y |
	courseNb _ beast courseNb.
	seenObstacle _ OrderedCollection new.
	1
		to: courseNb
		do: [:i | 
			curCourse _ beast direction + (i - (courseNb / 2.0) integerPart - 1 * 5).
			"Point to analyse"
			x _ beast x + ((Calculation degToRad: curCourse) cos * 30) integerPart.
			y _ beast y + ((Calculation degToRad: curCourse) sin * 30) integerPart.
			"Verification on area sides"
			(area isOutCoord: x @ y)
				ifTrue: [seenObstacle add: i].
			"Verification on obstacles"
			(area obstacleList
					select: [:obstacle | obstacle containsPoint: x @ y]) isEmpty
				ifFalse: [seenObstacle add: i]].
	^ seenObstacle! !

!Brain methodsFor: 'setting'!
removeTarget
	"Remove target to brain"

	target:= nil! !

!Brain methodsFor: 'setting' stamp: 'RB 8/21/2002 21:51'!
target: aPoint 
	"Set a new target to brain"
	target _ aPoint! !

!Brain methodsFor: 'testing'!
hasTarget
	"Answer true if the brain has a target"
	^ (target = nil) not! !


!Object class methodsFor: 'instance creation' stamp: 'RAA 6/22/2000 14:14'!
categoryForUniclasses
	"Answer the category into which to place unique-class instances"
	^ 'Morphic-UserObjects'! !

!Object class methodsFor: 'instance creation' stamp: 'sw 7/28/97 15:56'!
chooseUniqueClassName
	| i className |
	i _ 1.
	[className _ (self name , i printString) asSymbol.
	 Smalltalk includesKey: className]
		whileTrue: [i _ i + 1].
	^ className! !

!Object class methodsFor: 'instance creation' stamp: 'tk 8/22/1998 08:22'!
initialInstance
	"Answer the first instance of the receiver, generate an error if there is one already"
	"self instanceCount > 0 ifTrue: [self error: 'instance(s) already exist.']."
		"Debugging test that is very slow"
	^ self new! !

!Object class methodsFor: 'instance creation' stamp: 'sw 5/5/2000 09:30'!
initializedInstance
	^ self new! !

!Object class methodsFor: 'instance creation' stamp: 'sw 10/16/2000 10:58'!
instanceOfUniqueClass
	"Answer an instance of a unique subclass of the receiver"

	^ self instanceOfUniqueClassWithInstVarString: '' andClassInstVarString: ''! !

!Object class methodsFor: 'instance creation' stamp: 'tk 8/22/1998 08:27'!
instanceOfUniqueClassWithInstVarString: instVarString andClassInstVarString: classInstVarString
	"Create a unique class for the receiver, and answer an instance of it"

	^ (self newUniqueClassInstVars: instVarString 
		classInstVars: classInstVarString) initialInstance! !

!Object class methodsFor: 'instance creation' stamp: 'sw 10/23/1999 22:51'!
isUniClass
	^ false! !

!Object class methodsFor: 'instance creation' stamp: 'di 6/9/1999 14:27'!
newFrom: aSimilarObject
	"Create an object that has similar contents to aSimilarObject.
	If the classes have any instance varaibles with the same names, copy them across.
	If this is bad for a class, override this method."

	^ self basicNew copySameFrom: aSimilarObject! !

!Object class methodsFor: 'instance creation' stamp: 'tk 6/29/1998 12:11'!
newUniqueClassInstVars: instVarString classInstVars: classInstVarString
	"Create a unique class for the receiver"

	| aName aClass |
	self isSystemDefined ifFalse:
		[^ superclass newUniqueClassInstVars: instVarString classInstVars: classInstVarString].
	aName _ self chooseUniqueClassName.
	aClass _ self subclass: aName instanceVariableNames: instVarString 
		classVariableNames: '' poolDictionaries: '' category: self categoryForUniclasses.
	classInstVarString size > 0 ifTrue:
		[aClass class instanceVariableNames: classInstVarString].
	^ aClass! !

!Object class methodsFor: 'instance creation' stamp: 'sw 7/28/97 15:56'!
newUserInstance
	"Answer an instance of an appropriate class to serve as a user object in the containment hierarchy"

	^ self instanceOfUniqueClass! !

!Object class methodsFor: 'instance creation' stamp: 'tk 4/20/1999 15:46'!
readCarefullyFrom: textOrString
	"Create an object based on the contents of textOrString.  Return an error instead of putting up a SyntaxError window."

	| object ok |
	ok _ (textOrString isKindOf: Stream) or: [textOrString isKindOf: String].
	(ok or: [textOrString isKindOf: Text]) ifFalse: [^ self error: 'expected String or Text'].
	object _ Compiler evaluate: textOrString for: nil 
				notifying: #error: "signal we want errors" logged: false.
	(object isKindOf: self) ifFalse: [self error: self name, ' expected'].
	^object! !

!Object class methodsFor: 'instance creation' stamp: 'tk 4/18/1999 07:05'!
readFrom: aStream
	"Create an object based on the contents of aStream."

	| object ok |
	ok _ (aStream isKindOf: Stream) or: [aStream isKindOf: String].
	(ok or: [aStream isKindOf: Text]) ifFalse: [^ self error: 'expected String or Text'].
	object _ Compiler evaluate: aStream.
	(object isKindOf: self) ifFalse: [self error: self name, ' expected'].
	^object! !

!Object class methodsFor: 'documentation'!
howToModifyPrimitives
	"You are allowed to write methods which specify primitives, but please use 
	caution.  If you make a subclass of a class which contains a primitive method, 
	the subclass inherits the primitive.  The message which is implemented 
	primitively may be overridden in the subclass (E.g., see at:put: in String's 
	subclass Symbol).  The primitive behavior can be invoked using super (see 
	Symbol string:). 
	 
	A class which attempts to mimic the behavior of another class without being 
	its subclass may or may not be able to use the primitives of the original class.  
	In general, if the instance variables read or written by a primitive have the 
	same meanings and are in the same fields in both classes, the primitive will 
	work.  

	For certain frequently used 'special selectors', the compiler emits a 
	send-special-selector bytecode instead of a send-message bytecode.  
	Special selectors were created because they offer two advantages.  Code 
	which sends special selectors compiles into fewer bytes than normal.  For 
	some pairs of receiver classes and special selectors, the interpreter jumps 
	directly to a primitive routine without looking up the method in the class.  
	This is much faster than a normal message lookup. 
	 
	A selector which is a special selector solely in order to save space has a 
	normal behavior.  Methods whose selectors are special in order to 
	gain speed contain the comment, 'No Lookup'.  When the interpreter 
	encounters a send-special-selector bytecode, it checks the class of the 
	receiver and the selector.  If the class-selector pair is a no-lookup pair, 
	then the interpreter swiftly jumps to the routine which implements the 
	corresponding primitive.  (A special selector whose receiver is not of the 
	right class to make a no-lookup pair, is looked up normally).  The pairs are 
	listed below.  No-lookup methods contain a primitive number specification, 
	<primitive: xx>, which is redundant.  Since the method is not normally looked 
	up, deleting the primitive number specification cannot prevent this 
	primitive from running.  If a no-lookup primitive fails, the method is looked 
	up normally, and the expressions in it are executed. 
	 
	No Lookup pairs of (class, selector) 
	 
	SmallInteger with any of		+ - * /  \\  bitOr: bitShift: bitAnd:  // 
	SmallInteger with any of		=  ~=  >  <  >=  <= 
	Any class with					== 
	Any class with 					@ 
	Point with either of				x y 
	ContextPart with					blockCopy: 
	BlockContext with either of 		value value:
	"

	self error: 'comment only'! !

!Object class methodsFor: 'documentation'!
whatIsAPrimitive
	"Some messages in the system are responded to primitively. A primitive   
	response is performed directly by the interpreter rather than by evaluating   
	expressions in a method. The methods for these messages indicate the   
	presence of a primitive response by including <primitive: xx> before the   
	first expression in the method.   
	  
	Primitives exist for several reasons. Certain basic or 'primitive' 
	operations cannot be performed in any other way. Smalltalk without 
	primitives can move values from one variable to another, but cannot add two 
	SmallIntegers together. Many methods for arithmetic and comparison 
	between numbers are primitives. Some primitives allow Smalltalk to 
	communicate with I/O devices such as the disk, the display, and the keyboard. 
	Some primitives exist only to make the system run faster; each does the same 
	thing as a certain Smalltalk method, and its implementation as a primitive is 
	optional.  
	  
	When the Smalltalk interpreter begins to execute a method which specifies a 
	primitive response, it tries to perform the primitive action and to return a 
	result. If the routine in the interpreter for this primitive is successful, 
	it will return a value and the expressions in the method will not be evaluated. 
	If the primitive routine is not successful, the primitive 'fails', and the 
	Smalltalk expressions in the method are executed instead. These 
	expressions are evaluated as though the primitive routine had not been 
	called.  
	  
	The Smalltalk code that is evaluated when a primitive fails usually 
	anticipates why that primitive might fail. If the primitive is optional, the 
	expressions in the method do exactly what the primitive would have done (See 
	Number @). If the primitive only works on certain classes of arguments, the 
	Smalltalk code tries to coerce the argument or appeals to a superclass to find 
	a more general way of doing the operation (see SmallInteger +). If the 
	primitive is never supposed to fail, the expressions signal an error (see 
	SmallInteger asFloat).  
	  
	Each method that specifies a primitive has a comment in it. If the primitive is 
	optional, the comment will say 'Optional'. An optional primitive that is not 
	implemented always fails, and the Smalltalk expressions do the work 
	instead.  
	 
	If a primitive is not optional, the comment will say, 'Essential'. Some 
	methods will have the comment, 'No Lookup'. See Object 
	howToModifyPrimitives for an explanation of special selectors which are 
	not looked up.  
	  
	For the primitives for +, -, *, and bitShift: in SmallInteger, and truncated 
	in Float, the primitive constructs and returns a 16-bit 
	LargePositiveInteger when the result warrants it. Returning 16-bit 
	LargePositiveIntegers from these primitives instead of failing is 
	optional in the same sense that the LargePositiveInteger arithmetic 
	primitives are optional. The comments in the SmallInteger primitives say, 
	'Fails if result is not a SmallInteger', even though the implementor has the 
	option to construct a LargePositiveInteger. For further information on 
	primitives, see the 'Primitive Methods' part of the chapter on the formal 
	specification of the interpreter in the Smalltalk book."

	self error: 'comment only'! !

!Object class methodsFor: 'private' stamp: 'mir 8/22/2001 15:20'!
releaseExternalSettings
	"Do nothing as a default"! !

!Object class methodsFor: 'objects from disk' stamp: 'tk 1/8/97'!
createFrom: aSmartRefStream size: varsOnDisk version: instVarList
	"Create an instance of me so objects on the disk can be read in.  Tricky part is computing the size if variable.  Inst vars will be filled in later.  "

	^ self isVariable
		ifFalse: [self basicNew]
		ifTrue: ["instVarList is names of old class's inst vars plus a version number" 
				self basicNew: (varsOnDisk - (instVarList size - 1))]
! !

!Object class methodsFor: 'plugin generation' stamp: 'acg 9/17/1999 01:05'!
ccg: cg emitLoadFor: aString from: anInteger on: aStream

	cg emitLoad: aString asNakedOopFrom: anInteger on: aStream! !

!Object class methodsFor: 'plugin generation' stamp: 'acg 9/20/1999 13:01'!
ccg: cg generateCoerceToOopFrom: aNode on: aStream

	cg emitCExpression: aNode on: aStream! !

!Object class methodsFor: 'plugin generation' stamp: 'acg 10/5/1999 06:10'!
ccg: cg generateCoerceToValueFrom: aNode on: aStream

	cg emitCExpression: aNode on: aStream! !

!Object class methodsFor: 'plugin generation' stamp: 'acg 9/18/1999 16:09'!
ccg: cg prolog: aBlock expr: aString index: anInteger

	^cg ccgLoad: aBlock expr: aString asKindOf: self from: anInteger! !

!Object class methodsFor: 'plugin generation' stamp: 'acg 9/20/1999 11:12'!
ccgCanConvertFrom: anObject

	^anObject isKindOf: self! !

!Object class methodsFor: 'plugin generation' stamp: 'acg 9/17/1999 00:19'!
ccgDeclareCForVar: aSymbolOrString

	^'int ', aSymbolOrString! !

!Object class methodsFor: 'class initialization' stamp: 'ar 2/11/2001 02:00'!
flushDependents
	DependentsFields keysAndValuesDo:[:key :dep|
		key ifNotNil:[key removeDependent: nil].
	].
	DependentsFields finalizeValues.! !

!Object class methodsFor: 'class initialization' stamp: 'ar 2/11/2001 02:31'!
flushEvents
	"Object flushEvents"
	| msgSet |
	EventsFields keysAndValuesDo:[:rcvr :evtDict| rcvr ifNotNil:[
		"make sure we don't modify evtDict while enumerating"
		evtDict keys do:[:evtName|
			msgSet _ evtDict at: evtName ifAbsent:[nil].
			(msgSet == nil or:[msgSet isEmpty]) ifTrue:[rcvr removeEvent: evtName]]]].
	EventsFields finalizeValues. ! !

!Object class methodsFor: 'class initialization' stamp: 'ar 2/11/2001 01:37'!
initialize
	"Object initialize"
	EventsFields ifNil:[self initializeEventsFields].
	DependentsFields ifNil:[self initializeDependentsFields].! !

!Object class methodsFor: 'class initialization' stamp: 'ar 2/11/2001 01:41'!
initializeDependentsFields
	"Object initialize"
	DependentsFields _ WeakIdentityKeyDictionary new.
! !

!Object class methodsFor: 'class initialization' stamp: 'ar 2/11/2001 01:41'!
initializeEventsFields
	"Object initialize"
	EventsFields _ WeakIdentityKeyDictionary new.
! !

!Object class methodsFor: 'class initialization' stamp: 'ar 2/11/2001 01:45'!
reInitializeDependentsFields
	"Object reInitializeDependentsFields"
	| oldFields |
	oldFields _ DependentsFields.
	DependentsFields _ WeakIdentityKeyDictionary new.
	oldFields keysAndValuesDo:[:obj :deps|
		deps do:[:d| obj addDependent: d]].
! !

!Object class methodsFor: 'class initialization' stamp: 'ar 2/11/2001 02:15'!
reInitializeEventsFields
	"Object reInitializeEventsFields"
	| oldFields |
	oldFields _ EventsFields.
	EventsFields _ WeakIdentityKeyDictionary new.
	oldFields keysAndValuesDo:[:rcvr :evtDict|
		evtDict keysAndValuesDo:[:evt :msgSet|
			msgSet do:[:msg| rcvr when: evt perform: msg]]].
! !


!Area class methodsFor: 'creation'!
new: newHeight on: newWidth 
	"Constructor of an area instance"

	^self new initialize: newHeight on: newWidth! !


!AreaMorph class methodsFor: 'opening' stamp: 'RB 8/12/2002 22:38'!
open
	^ self new openInWorld! !


!Beast class methodsFor: 'creation' stamp: 'RB 8/22/2002 21:40'!
new: aPoint direction: curDir speed: curSpeed color: aColor 
	"Constructor of an Beast instance"
	| newBeast |
	newBeast _ self new
				initialize: aPoint
				direction: curDir
				speed: curSpeed
				color: aColor.
	"Allows a new brain at the beast"
	newBeast
		brain: (Brain new: newBeast).
	^ newBeast! !


!BeastMorph class methodsFor: 'creation' stamp: 'RB 8/11/2002 23:13'!
new: aBeast
	"Create a BeastMorph who represents a beast"
	^ self new initialize: aBeast! !


!BehaviourAvoid class methodsFor: 'creation'!
new: newBrain on: newArea with: newWeight 
	"Constructor of behavior instance"
	^ self new
		initialize: newBrain
		on: newArea
		with: newWeight! !


!BehaviourFlock class methodsFor: 'creation'!
new: newBrain on: newArea with: newWeight 
	"Constructor of behavior instance"
	^ self new
		initialize: newBrain
		on: newArea
		with: newWeight! !


!BehaviourPredator class methodsFor: 'creation'!
new: newBrain on: newArea with: newWeight 
	"Constructor of behavior instance"
	| behavior |
	behavior _ self new
				initialize: newBrain
				on: newArea
				with: newWeight.
	behavior time: 0.
	^ behavior! !


!BehaviourPsycho class methodsFor: 'creation'!
new: newBrain on: newArea with: newWeight 
	"Constructor of behavior instance"
	| behavior |
	behavior := self new
		initialize: newBrain
		on: newArea
		with: newWeight.
	behavior time: 0.
	^ behavior! !


!BehaviourRandom class methodsFor: 'creation'!
new: newBrain on: newArea with: newWeight 
	"Constructor of behavior instance"
	^ self new
		initialize: newBrain
		on: newArea
		with: newWeight! !


!BehaviourRound class methodsFor: 'creation'!
new: newBrain on: newArea with: newWeight 
	"Constructor of behavior instance"
	^ self new
		initialize: newBrain
		on: newArea
		with: newWeight! !


!BehaviourStraight class methodsFor: 'creation'!
new: newBrain on: newArea with: newWeight 
	"Constructor of behavior instance"
	^ self new
		initialize: newBrain
		on: newArea
		with: newWeight! !


!BehaviourTarget class methodsFor: 'creation'!
new: newBrain on: newArea with: newWeight 
	"Constructor of behavior instance"
	^ self new
		initialize: newBrain
		on: newArea
		with: newWeight! !


!Brain class methodsFor: 'creation'!
new: beast
	"Constructor of brain instance contained into a beast"
	^ self new initialize: beast! !


!Calculation class methodsFor: 'direction'!
angleContained: angle between: min to: max
	"Answers if an angle is between two angles"

	(min > max) ifTrue: [^(angle < max) | (angle > min)]
				ifFalse: [((angle < max) & (angle > min)) ifTrue: [^true] 
														ifFalse: [^false]]! !

!Calculation class methodsFor: 'direction'!
formedAngleBy: dir1 and: dir2
	"Absolute degree angle formed by two direction of space"

	| angle newDir1 newDir2 |
	angle := (dir2 - dir1) abs.
	(angle > 180) ifTrue: [(dir1 < dir2) ifTrue: [newDir1 := dir1 + 360. newDir2 := dir2]
									  ifFalse: [newDir2 := dir2 + 360. newDir1 := dir1].
						 angle := (newDir2 - newDir1) abs].
	^angle	! !

!Calculation class methodsFor: 'direction'!
reboundDirection: direction on: normalDirection
	"Return the value of the angle before rebound on a surface with a specified
	normal angle"

	| angleDiff |
	angleDiff := ((normalDirection + 180) \\ 360) - direction.
	^(normalDirection + angleDiff) \\ 360
! !

!Calculation class methodsFor: 'direction'!
simplifyAngle: angle
	"Simplify an angle and return its value between 0 and 360 degrees"

	| newAngle |
	newAngle := angle.
	[(newAngle < 0) | (newAngle > 360)] whileTrue: [
		(newAngle < 0) ifTrue: [newAngle := newAngle + 360]
					    ifFalse: [newAngle := newAngle - 360]].
	^newAngle! !

!Calculation class methodsFor: 'direction' stamp: 'RB 8/21/2002 21:14'!
vectorDirection: point1 to: point2 
	"Return the vector direction formed by two points"
	| hyp adj |
	hyp _ self distance: point1 to: point2 .
	adj _ (point2 x - point1 x) abs.
	"Same X"
	point1 x = point2 x
		ifTrue: [point1 y < point2 y
				ifTrue: [^ 90]
				ifFalse: [^ 270]].
	"Same Y"
	point1 y = point2 y
		ifTrue: [point1 x > point2 x
				ifTrue: [^ 180]
				ifFalse: [^ 0]].
	"Other possibilities"
	point1 x < point2 x & (point1 y < point2 y)
		ifTrue: [^ self radToDeg: (adj / hyp) arcCos].
	point1 x > point2 x & (point1 y < point2 y)
		ifTrue: [^ 180
				- (self radToDeg: (adj / hyp) arcCos)].
	point1 x > point2 x & (point1 y > point2 y)
		ifTrue: [^ 180
				+ (self radToDeg: (adj / hyp) arcCos)].
	point1 x < point2 x & (point1 y > point2 y)
		ifTrue: [^ 360
				- (self radToDeg: (adj / hyp) arcCos)].
	^ 0! !

!Calculation class methodsFor: 'distance' stamp: 'RB 8/21/2002 21:05'!
distance: point1 to: point2
	"Distance between two points"
	^ ((point1 x - point2 x) squared + (point1 y - point2 y) squared) sqrt! !

!Calculation class methodsFor: 'units'!
degToRad: deg
	"Translate a degree angle to in radian"

     ^(deg * Float pi) / 180! !

!Calculation class methodsFor: 'units'!
radToDeg: radian
	"Translate a radian angle in degree"

     ^(radian / 3.14159265) * 180! !

!Calculation class methodsFor: 'random' stamp: 'RB 8/21/2002 22:05'!
randomBool
	"Return a random boolean"
	(0 to: 1) atRandom == 1
		ifTrue: [^ true]
		ifFalse: [^ false]! !


!Obstacle methodsFor: 'accessing'!
height
	"Return the width of the obstacle"
	^ height! !

!Obstacle methodsFor: 'accessing' stamp: 'RB 8/22/2002 22:30'!
position
	"Return the position of the left top corner"
	^ position! !

!Obstacle methodsFor: 'accessing'!
width
	"Return the width of the obstacle"
	^ width! !

!Obstacle methodsFor: 'direction' stamp: 'RB 8/12/2002 00:39'!
reboundDirection: direction onPoint: xPoint and: yPoint 
	"Return the direction after rebound on the obstacle"
	"If the point isn't contained, it isn't rebound"
	| up down right left newDirection |
	(self containsPoint: xPoint @ yPoint)
		ifFalse: [^ direction].
	up _ (yPoint - y) abs.
	down _ (y + height - xPoint) abs.
	right _ (x + width - xPoint) abs.
	left _ xPoint - x.
	up <= right & (up <= left) & (up <= down)
		ifTrue: [right < 10
				ifTrue: [newDirection _ 315]
				ifFalse: [left < 10
						ifTrue: [newDirection _ 225]
						ifFalse: [newDirection _ Calculation reboundDirection: direction on: 270]]]
		ifFalse: [(right <= up & (right <= down) & (right <= left))
				ifTrue: [up < 10
						ifTrue: [newDirection _ 315]
						ifFalse: [down < 10
								ifTrue: [newDirection _ 45]
								ifFalse: [newDirection _ Calculation reboundDirection: direction on: 0]]]
				ifFalse: [((down <= left) & (down <= up) & (down <= right))
						ifTrue: [right < 10
								ifTrue: [newDirection _ 45]
								ifFalse: [left < 10
										ifTrue: [newDirection _ 135]
										ifFalse: [newDirection _ Calculation reboundDirection: direction on: 90]]]
						ifFalse: [(left <= up & (left <= right) & (left <= down))
								ifTrue: [up < 10
										ifTrue: [newDirection _ 225]
										ifFalse: [down < 10
												ifTrue: [newDirection _ 135]
												ifFalse: [newDirection _ Calculation reboundDirection: direction on: 180]]]
								ifFalse: [newDirection _ direction + 180 \\ 360]]]].
	^ newDirection! !

!Obstacle methodsFor: 'direction' stamp: 'RB 8/12/2002 00:43'!
reboundDirectionPixel: direction onPoint: xPoint and: yPoint 
	"Return the direction after rebound on the obstacle, 
	with pixels correction"
	^ self reboundDirection: direction onPoint: xPoint and: yPoint ! !

!Obstacle methodsFor: 'initializing' stamp: 'RB 8/22/2002 22:25'!
initialize: aPoint width: w height: h 
	"Initialize an instance of RectangleObstacle"
	position := aPoint.
	width _ w.
	height _ h! !

!Obstacle methodsFor: 'testing' stamp: 'RB 8/22/2002 22:26'!
containsPoint: aPoint 
	"Verify if a point is contained into the obstacle"
	^ position x < aPoint x & (aPoint x < (position x + width)) & (position y < aPoint y) & (aPoint y < (position y + height))! !


!Obstacle class methodsFor: 'creation' stamp: 'RB 8/22/2002 22:25'!
new: aPoint width: w height: h 
	"Constructor of an obstacle instance"
	^ self new
		initialize: aPoint
		width: w
		height: h! !


!ObstacleMorph methodsFor: 'initializing' stamp: 'RB 8/22/2002 22:30'!
initialize: anObstacle 
	"Initialize an ObstacleMorph depending an obstacle"
	super initialize.
	self color: Color black.
	self extent: anObstacle width @ anObstacle height.
	self
		bounds: (self bounds translateBy: anObstacle position)! !

!ObstacleMorph methodsFor: 'updating' stamp: 'RB 8/11/2002 22:25'!
update: changeType 
	changeType == #removed
		ifTrue: [self owner removeAllMorphsIn: {self}]! !


!ObstacleMorph class methodsFor: 'creation' stamp: 'RB 8/11/2002 23:19'!
new: anObstacle
	"Creates an ObstacleMorph instance depending to an obstacle"
	^ self new initialize: anObstacle! !


!SqueakLife methodsFor: 'callbacks' stamp: 'foo 9/18/2002 11:31'!
about
	"About Squeak"
	PopUpMenu class inform: '

        Squeak Life  1.0        
      
     Bertuli Roland
          rolab.free.fr
'! !

!SqueakLife methodsFor: 'callbacks' stamp: 'RB 8/26/2002 22:38'!
addBeast
	"Add a beast at the center of the area"
	| aBehavior |
	aBehavior _ Smalltalk at: (FillInTheBlank request: 'Add Beast: enter a  
	behavior') asSymbol.
	areaMorph
		addBeast: area center
		color: Color black
		behavior: aBehavior! !

!SqueakLife methodsFor: 'callbacks' stamp: 'foo 9/18/2002 11:18'!
clear
	"Clear our world"
	area clear
	! !

!SqueakLife methodsFor: 'callbacks' stamp: 'br 8/15/2002 14:10'!
newWorld
	"Create a new world"
	area clear.
	world = 1
		ifTrue: [areaMorph attack.
			world _ 2]
		ifFalse: [world = 2
				ifTrue: [areaMorph target.
					world _ 3]
				ifFalse: [world = 3
						ifTrue: [areaMorph pigFlock.
							world _ 1]]]! !

!SqueakLife methodsFor: 'callbacks' stamp: 'foo 8/13/2002 10:12'!
quit
	"Quit Nature Life"
	area isRunning
		ifTrue: [area endEvolution].
	frame delete! !

!SqueakLife methodsFor: 'callbacks' stamp: 'foo 8/13/2002 10:11'!
start
	"Start world evolution"
	area startEvolution! !

!SqueakLife methodsFor: 'callbacks' stamp: 'foo 8/13/2002 10:12'!
stop
"Stop world evolution"
	area stopEvolution! !

!SqueakLife methodsFor: 'window' stamp: 'foo 8/13/2002 10:18'!
controlPanel
	| p b |
	p _ PasteUpMorph new.
	self buttons
		inject: 0.0
		into: [:offset :array | 
			b _ PluggableButtonMorph
						on: self
						getState: #buttonState
						action: #runTests.
			p addMorphFront: b.
			b
				bounds: (p bounds bottomLeft + (offset @ 0) extent: 30 @ 20).
			self halt.
			offset + 30].
	^ p! !

!SqueakLife methodsFor: 'window' stamp: 'foo 8/13/2002 10:18'!
openAsMorph
	| heightButtons s b |
	(frame _ SystemWindow labelled: self windowLabel) model: self.
	areaMorph _ AreaMorph new.
	area _ areaMorph area.
	"We initialize world flag"
	world _ 1.
	heightButtons _ 0.05.
	frame
		addMorph: areaMorph
		frame: (0.0 @ heightButtons extent: 1.0 @ (1.0 - heightButtons)).
	s _ 1.0 / self buttons size.
	self buttons
		inject: 0.0
		into: [:offset :array | 
			b _ SimpleButtonMorph new.
			b target: self.
			b actionSelector: array second.
			b label: array first.
			frame
				addMorph: b
				frame: (offset @ 0.0 extent: s @ heightButtons).
			offset + s].
	frame openInWorldExtent: 400 @ 400! !

!SqueakLife methodsFor: 'window' stamp: 'foo 9/5/2002 17:34'!
windowLabel
	^ 'Squeak Life'! !

!SqueakLife methodsFor: 'buttons' stamp: 'rb 8/11/2002 15:46'!
buttonState
	^true! !

!SqueakLife methodsFor: 'buttons' stamp: 'foo 9/18/2002 11:19'!
buttons
	"Button list of the Nature Life window"
	^ #(#('Start' #start) #('Clear' #clear) #('New World' #newWorld) #('Add Beast' #addBeast) #('About' #about) #('Quit' #quit) )! !


!SqueakLife class methodsFor: 'as yet unclassified' stamp: 'rb 8/11/2002 15:34'!
open
	self new openAsMorph! !

!SqueakLife class methodsFor: 'starting' stamp: 'RB 8/12/2002 22:39'!
start
	self new openAsMorph! !

Object initialize!
